
#include <windows.h>
#include <Streams.h>
#include <initguid.h>
#include <mmreg.h>
#include ".\pieceadpcmconv.h"


//---------------------------------------------------------------------------
// P/ECEadpcv\[X̔ 
//---------------------------------------------------------------------------
#define WAVEMAX (32767-4096)
#define WAVEMIN (-32767+4096)

//#define PCM_TEST	//PCMɂăGR[hfR[h̊mFꍇ̓Rg

short dct[]={
  233,549,453,375,310,233,233,233,
  233,233,233,233,310,375,453,549,
};

int iabs(int num)
{
  if(num<0)
    return -num;
  return num;
}

int isign(int num)
{
  if(num<0)
    return -1;
  return 1;
}

int check1sample(int diff,int delta)
{
  int sign=1,i,dist=65536,ret;

  dist=iabs(diff-delta*(-7));
  ret=-7;
  for(i=-6;i<=7;i++){
    if(iabs(diff-delta*i)<dist){
      dist=iabs(diff-delta*i);
      ret=i;
    }
  }
  return ret;
}

//PCMADPCMւ̃GR[h
void encode(unsigned char *adp,signed short *wave,int loopnum)
{
  int delta=16,oldpcm=0,diff,nowpcm,i,adph,adpl;

  for(i=0;i<loopnum;i++){
    nowpcm=*wave++;
    if(nowpcm>WAVEMAX) nowpcm=WAVEMAX;
    if(nowpcm<WAVEMIN) nowpcm=WAVEMIN;
    diff=nowpcm-oldpcm;
    adph=check1sample(diff,delta);
    if(iabs((delta*dct[adph+8])>>8)<16){
      if(adph>=0)
	adph=-4;
      else
	adph=4;
    }
    oldpcm=oldpcm+adph*delta;
    delta=(delta*dct[adph+8])>>8;
    adph+=8;
    
    nowpcm=*wave++;
    if(nowpcm>WAVEMAX) nowpcm=WAVEMAX;
    if(nowpcm<WAVEMIN) nowpcm=WAVEMIN;
    diff=nowpcm-oldpcm;
    adpl=check1sample(diff,delta);
    if(iabs((delta*dct[adpl+8])>>8)<16){
      if(adpl>=0)
	adpl=-4;
      else
	adpl=4;
    }
    oldpcm=oldpcm+adpl*delta;
    delta=(delta*dct[adpl+8])>>8;
    adpl+=8;
    
    *adp++=(unsigned char)((adph<<4)|(adpl&15));
  }
}

//ADPCMPCMւ̃fR[h
void decode(signed short *wave,unsigned char *adp,int size)
{
  int delta=16,pcm=0,i;
  for(i=0;i<size;i++){
    int h,l;
    h=*adp++;
    l=h&0xf;
    h>>=4;
    pcm+=delta*(h-8);
    delta=(delta*dct[h])>>8;
    *wave++=(short)pcm;
    pcm+=delta*(l-8);
    delta=(delta*dct[l])>>8;
    *wave++=(short)pcm;
  }
}

//---------------------------------------------------------------------------
// tB^̐錾 
//---------------------------------------------------------------------------
#define PCE_CC				'PCEA'	//PieceADPCMtH[}bgFOURCC
#define OUT_FREQ			(16000)	//o͎̎g

//tB^
static const WCHAR g_wszFilterName[] = L"Piece ADPCM Converter";

// Setup information

const AMOVIESETUP_MEDIATYPE sudInMediaTypes[] =
{
	{ &MEDIATYPE_Audio, &MEDIASUBTYPE_PCM },
};

const AMOVIESETUP_MEDIATYPE sudOutMediaTypes[] =
{
#ifndef PCM_TEST
	{ &MEDIATYPE_Audio, &MEDIASUBTYPE_WAVE },
#else
	{ &MEDIATYPE_Audio, &MEDIASUBTYPE_PCM  },
#endif	//PCM_TEST
};

const AMOVIESETUP_PIN sudpPins[] =
{
    { L"Input",             // s
      FALSE,                // ̃s̓_O邩H
      FALSE,                // o̓sH
      FALSE,                // tB^̓[̃CX^X쐬ł邩H
      FALSE,                // tB^͕̃CX^X쐬ł邩H
      &CLSID_NULL,          // ݎgĂȂ
      NULL,                 // ݎgĂȂ
      1,                    // fBA^Cv̐
      sudInMediaTypes       // fBA^Cvւ̃|C^
    },
    { L"Output",            // s
      FALSE,                // ̃s̓_O邩H
      TRUE,                 // o̓sH
      FALSE,                // tB^̓[̃CX^X쐬ł邩H
      FALSE,                // tB^͕̃CX^X쐬ł邩H
      &CLSID_NULL,          // ݎgĂȂ
      NULL,                 // ݎgĂȂ
      1,                    // fBA^Cv̐
      sudOutMediaTypes      // fBA^Cvւ̃|C^
    }
};

const AMOVIESETUP_FILTER sudPieceADPCMConv =
{
    &CLSID_PieceADPCMConv,	// tB^ CLSID
    g_wszFilterName,		// tB^
    MERIT_DO_NOT_USE,	    // bg
    2,                      // s^Cv̐
    sudpPins                // sւ̃|C^
};


// List of class IDs and creator functions for the class factory. This
// provides the link between the OLE entry point in the DLL and an object
// being created. The class factory will call the static CreateInstance

CFactoryTemplate g_Templates[] = {
    { 
	  g_wszFilterName,					//O
      &CLSID_PieceADPCMConv,			//CLSID
      CPieceADPCMConv::CreateInstance,	//쐬֐
      NULL,
      &sudPieceADPCMConv				//tB^ւ̃|C^
	} 
};
int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);


//---------------------------------------------------------------------------
// DLL֘A 
//---------------------------------------------------------------------------
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
//DLLGg|Cg
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}
//---------------------------------------------------------------------------
// WXgւ̓o^
STDAPI DllRegisterServer()
{
	return AMovieDllRegisterServer2(TRUE);
}
//---------------------------------------------------------------------------
// WXg̉
STDAPI DllUnregisterServer()
{
	return AMovieDllRegisterServer2(FALSE);
}
//---------------------------------------------------------------------------
// Piece ADPCM Converter tB^NX 
//---------------------------------------------------------------------------
CPieceADPCMConv::CPieceADPCMConv(void) :
				CTransformFilter(NAME("Piece ADPCM Converter"),0,CLSID_PieceADPCMConv) 
{
	//RXgN^

	//e탁ȍ
	InitMember();

}
//---------------------------------------------------------------------------
CPieceADPCMConv::~CPieceADPCMConv(void)
{
	//fXgN^

	//e탁o̍폜

}
//---------------------------------------------------------------------------
void CPieceADPCMConv::InitMember(void)
{

	//ȍ

	memset(m_abyWork,0,sizeof(m_abyWork));
	m_lWorkUse = 0;	
}
//---------------------------------------------------------------------------
CUnknown * WINAPI CPieceADPCMConv::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
	//CX^X̍쐬

    CPieceADPCMConv *pFilter = new CPieceADPCMConv();
    if (pFilter== NULL) 
    {
        *pHr = E_OUTOFMEMORY;
    }
    return pFilter;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::MediaCheck(const CMediaType *MediaType)
{
	//fBA^Cṽ`FbN
	//s̐ڑ₢킹ŉxĂяo܂

	//AudioH
	if( IsEqualGUID( *MediaType->Type(),MEDIATYPE_Audio ) )				
	{
		//PCMH
		if( IsEqualGUID( *MediaType->Subtype(),MEDIASUBTYPE_PCM) ) 	  
		{
			WAVEFORMATEX *pai=(WAVEFORMATEX *)MediaType->Format();
			
			//16kHz16bitmH
			if((pai->wFormatTag == WAVE_FORMAT_PCM) &&	//PCM
			   //(pai->nSamplesPerSec == OUT_FREQ) &&	//16kHz	͂Ŏgϊ̂łȂłOK
			   (pai->wBitsPerSample == 16) &&			//16bit
			   (pai->nBlockAlign == 2) &&				//16bit == 2bytes
			   (pai->nChannels == 1))					//m
			{
				//OK
				return S_OK;
			}
		}
	}

	//NG
	return VFW_E_TYPE_NOT_ACCEPTED;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::CheckInputType(const CMediaType *mtIn)
{
	//̓fBA^Cṽ`FbN
	//s̐ڑ₢킹ŉxĂяo܂

	//`̃`FbN
	if ((mtIn->majortype  != MEDIATYPE_Audio)     ||
        (mtIn->subtype    != MEDIASUBTYPE_PCM)    ||
        (mtIn->formattype != FORMAT_WaveFormatEx) || 
        (mtIn->cbFormat < sizeof(WAVEFORMATEX)))
    {
		//̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	//WAVẼ`FbN
	//16kHz16bitmH
	WAVEFORMATEX *pAih = 
        reinterpret_cast<WAVEFORMATEX*>(mtIn->pbFormat);
    if((pAih->wFormatTag     != WAVE_FORMAT_PCM) ||	//PCM
	   //(pAih->nSamplesPerSec != OUT_FREQ)      || //16kHz ͂Ŏgϊ̂łȂłOK
	   (pAih->wBitsPerSample != 16)              ||	//16bit
	   (pAih->nBlockAlign    != 2)               ||	//16bit == 2bytes
	   (pAih->nChannels      != 1))					//m
	{
        //̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	//SĖȂ
	return S_OK;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	//fBA^Cv̎擾

	//ڑς݂H
	ASSERT(m_pInput->IsConnected());	
	if (m_pInput->IsConnected() == FALSE) {
        return E_UNEXPECTED;
    }

	//Do̓^CṽCfbNXԍ0ȏォH
    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }

	//o̓^Cv͂Pł
    if (iPosition == 0)
    {
		//̓s̃fBA^Cv擾
		//̓sWAVEtH[}bgx[Xɂ
		AM_MEDIA_TYPE mt;
        HRESULT hr = m_pInput->ConnectionMediaType(&mt);
        if (FAILED(hr))
        {
            return hr;
        }
		
		//x[XƂȂtH[}bgubNRs[
		*pMediaType = mt;

#ifndef PCM_TEST
		//o̓fBA^Cvݒ
        FOURCCMap fccMap = FOURCCMap(PCE_CC); 
        pMediaType->subtype = static_cast<GUID>(fccMap);//FOURCCR[hݒ
        pMediaType->SetSampleSize(0);					//iPieceMovieFileMuxtB^ł͎gȂ̂0
        pMediaType->SetTemporalCompression(FALSE);		//Xg[͎n(t[)kgpĂ܂

		//WAVEtH[}bg̕ύX
		WAVEFORMATEX *ptWave = (WAVEFORMATEX*)pMediaType->Format();

		ptWave->wFormatTag      = WAVE_FORMAT_ADPCM;	//ADPCM
		ptWave->nSamplesPerSec  = OUT_FREQ;				//16kHz
		ptWave->wBitsPerSample  = 4;					//4bit
		ptWave->nBlockAlign     = 1;					//قƂ0.5
		ptWave->nChannels       = 1;					//m
		ptWave->nAvgBytesPerSec = OUT_FREQ * 4 / 8;		//rbg[g 

#else
		//WAVEtH[}bg̕ύX
		WAVEFORMATEX *ptWave = (WAVEFORMATEX*)pMediaType->Format();

		ptWave->wFormatTag      = WAVE_FORMAT_PCM;		//PCM
		ptWave->nSamplesPerSec  = OUT_FREQ;				//16kHz
		ptWave->wBitsPerSample  = 16;					//16bit
		ptWave->nBlockAlign     = 2;					//
		ptWave->nChannels       = 1;					//m
		ptWave->nAvgBytesPerSec = OUT_FREQ * 2;			//rbg[g 

#endif	//PCM_TEST

		//ꎞIɐtH[}bg ubN
	    FreeMediaType(mt);
			
		return S_OK;
    }
    // else
	return VFW_S_NO_MORE_ITEMS;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut)
{
	//񎦂ꂽo̓^Cv݂̓̓^Cv
	//݊邩ǂ𒲂ׂ

	//̓^Cṽ`FbN
	if(CheckInputType(mtIn) != S_OK)
	{
        return VFW_E_TYPE_NOT_ACCEPTED;	//_[
    }

#ifndef PCM_TEST

	//o̓^Cṽ`FbN
	FOURCCMap fccMap = FOURCCMap(PCE_CC); 
        
	if ((mtOut->majortype  != MEDIATYPE_Audio)           ||
        (mtOut->subtype    != static_cast<GUID>(fccMap)) ||
        (mtOut->formattype != FORMAT_WaveFormatEx)       || 
        (mtOut->cbFormat < sizeof(WAVEFORMATEX)))
    {
		//̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	//WAVẼ`FbN
	//16kHz4bitmADPCMH
	WAVEFORMATEX *pAoh = 
        reinterpret_cast<WAVEFORMATEX*>(mtOut->pbFormat);
    if((pAoh->wFormatTag     != WAVE_FORMAT_ADPCM) ||	//ADPCM
	   (pAoh->nSamplesPerSec != OUT_FREQ)          ||	//16kHz
	   (pAoh->wBitsPerSample != 4)                 ||	//4bit
	   (pAoh->nBlockAlign    != 1)                 ||	//قƂ0.5
	   (pAoh->nChannels      != 1))						//m
	{
        //̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

#else

	//o̓^Cṽ`FbN
	if ((mtOut->majortype  != MEDIATYPE_Audio)      ||
        (mtOut->subtype    != MEDIASUBTYPE_PCM)		||
        (mtOut->formattype != FORMAT_WaveFormatEx)  || 
        (mtOut->cbFormat < sizeof(WAVEFORMATEX)))
    {
		//̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	//WAVẼ`FbN
	//16kHz16bitmPCMH
	WAVEFORMATEX *pAoh = 
        reinterpret_cast<WAVEFORMATEX*>(mtOut->pbFormat);
    if((pAoh->wFormatTag     != WAVE_FORMAT_PCM) ||	//PCM
	   (pAoh->nSamplesPerSec != OUT_FREQ)        ||	//16kHz
	   (pAoh->wBitsPerSample != 16)              ||	//16bit
	   (pAoh->nBlockAlign    != 2)               ||	//
	   (pAoh->nChannels      != 1))					//m
	{
        //̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

#endif	//PCM_TEST

    // ׂĖȂ
    return S_OK;
}
//---------------------------------------------------------------------------
DWORD CPieceADPCMConv::GetInputSamplePerSec(void)
{

	//͂ꂽf[^̃TvOg擾
	AM_MEDIA_TYPE mt;
	HRESULT hr = m_pInput->ConnectionMediaType(&mt);
	if (FAILED(hr))
	{
		return 0;
	}
	
	WAVEFORMATEX *ptWave = (WAVEFORMATEX*)mt.pbFormat;			
	DWORD dwSamplePerSec = ptWave->nSamplesPerSec;

	//ꎞIɐtH[}bg ubN
	FreeMediaType(mt);

	return dwSamplePerSec;
}
//---------------------------------------------------------------------------
long CPieceADPCMConv::Get16kHzBuffer(long lDataSize)
{

	//16kHzϊɕKvȃobt@TCY擾

	//͂ꂽf[^̃TvOg擾
	double dSamplePerSec = (double)GetInputSamplePerSec();
	
	//͉̃TvOg16kHzɕϊ
	//̃obt@{vZ
	double dBuffMag = (double)OUT_FREQ / dSamplePerSec;

	//16kHzϊɕKvȃobt@Zo
	//oCgɂȂ悤ɒ܂B
	lDataSize = (long)((double)lDataSize * dBuffMag) & 0xFFFFFFFE;

	return lDataSize;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::DecideBufferSize(IMemAllocator *pAlloc,
									      ALLOCATOR_PROPERTIES *pProp)
{
	//AP[^ݒ

	HRESULT hr = NOERROR;

    //ڑς݂H
	if(m_pInput->IsConnected() == FALSE)
    {
        return E_UNEXPECTED;
    }

	//|C^`FbN
    CheckPointer(pAlloc,E_POINTER);
    CheckPointer(pProp,E_POINTER);

    pProp->cBuffers = 1;
    pProp->cbAlign  = 1;

	ALLOCATOR_PROPERTIES InProps;
    IMemAllocator * pInAlloc = NULL;

    hr = m_pInput->GetAllocator(&pInAlloc);
    if(SUCCEEDED(hr))
    {
        hr = pInAlloc->GetProperties(&InProps);
        if(SUCCEEDED(hr))
        {
			//16kHzgϊɕKvȃobt@̃TCYvZ
			//̓f[^̎g͉łOKȂ̂ŁAϊKv
			//Ɣfꂽ̂A̓f[^̃TCYŎ擾
			//łȂ̂ŁA傫߂Ƀobt@Ă܂B
			long lBufferSize;// = Get16kHzBuffer(pProp->cbBuffer);	

			lBufferSize = 96000 * 3;

#ifndef PCM_TEST
			//O̖GR[hǉꍇ
			//̂ŁA1t[]ɊmۂĂ
			pProp->cbBuffer = ((lBufferSize + 3) / 4) +
								PIECE_MOVIE_AUDIO_DATA_SIZE;
#else
			pProp->cbBuffer = lBufferSize;	
#endif	//PCM_TEST
        }
        pInAlloc->Release();
    }

	// AP[^ vpeBݒ肷
    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProp,&Actual);
    if(FAILED(hr))
    {
        return hr;
    }

    // ꍇAۂ̌ʂmF
    if(pProp->cBuffers > Actual.cBuffers ||
       pProp->cbBuffer > Actual.cbBuffer)
    {
        return E_FAIL;
    }

    return NOERROR;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin)
{

	//sڑ̏

	return S_OK;
}
//---------------------------------------------------------------------------	
HRESULT CPieceADPCMConv::StartStreaming()
{
	
	//Xg[Jn̏
	
	return S_OK;
}
//---------------------------------------------------------------------------
HRESULT CPieceADPCMConv::Transform(IMediaSample *pIn, IMediaSample *pOut)
{
	
	//tH[}bgϊ

	// ɂȂobt@ւ̃|C^擾
    BYTE *pBufferIn, *pBufferOut;
	HRESULT hr;

	hr = pIn->GetPointer(&pBufferIn);
    if (FAILED(hr))
    {
        return hr;
    }
    hr = pOut->GetPointer(&pBufferOut);
    if (FAILED(hr))
    {
        return hr;
    }

	//Lȃf[^TCY擾
	long lSrcDataSize = pIn->GetActualDataLength();	
	long lDstDataSize = Get16kHzBuffer(lSrcDataSize);
	int ADPCM_Size;

	//ϊ̃obt@̔{Zo
	double dBuffMag = (double)OUT_FREQ / (double)GetInputSamplePerSec();
	BYTE *p16kHzData = new BYTE[lDstDataSize];

	//AbvTvOɂȂ邩H
	if(dBuffMag > 1.0)
	{
		//̃f[^16kHzɕԊg
		int nMax = lDstDataSize / 2;
		int nPos;
		short *psSrc = (short*)pBufferIn;
		short *psDst = (short*)p16kHzData;
		int nWave,nSrc1,nSrc2;
		double dRate;

		for(nPos = 0;nPos < nMax;++nPos)
		{
			//ΏۂƂȂf[^ʒuZo
			nSrc1 = (int)(nPos / dBuffMag);
			nSrc2 = nSrc1 + 1;

			//銄Zo
			dRate = 1.0 - (((double)nPos / dBuffMag) - (double)nSrc1);

			//
			if(nSrc2 < nMax)
			{
				nWave = (int)((double)psSrc[nSrc1] * dRate +
					 	      (double)psSrc[nSrc2] * (1.0 - dRate));
			}
			else
			{
				nWave = (int)((double)psSrc[nSrc1] * dRate);
			}			
			
			//
			if(nWave > 32767) nWave = 32767;
			else if(nWave < -32768) nWave = -32768;
			
			//
			psDst[nPos] = (short)nWave;
		}
	}
	//_ETvOɂȂ邩H
	else if(dBuffMag < 1.0)
	{
		//̃f[^16kHzɖʐϕϖ@ŏk
		int nMax    = lDstDataSize / 2;
		int nSrcMax = lSrcDataSize / 2;
		int nPos,nSrc,n;
		short *psSrc = (short*)pBufferIn;
		short *psDst = (short*)p16kHzData;
		long lAve;
		double dRange = ((double)OUT_FREQ / dBuffMag) / (double)OUT_FREQ;
		int nRange = (int)(dRange);
		
		for(nPos = 0;nPos < nMax;++nPos)
		{
			//ς͈͂̃f[^擾
			nSrc = (int)((double)nPos * dRange);

			lAve = 0;
			for(n = 0;n < nRange;++n)
			{
				if((nSrc + n) < nSrcMax)
					lAve += (long)psSrc[nSrc + n];				
			}
			
			//ς
			lAve = lAve / nRange;
		
			//
			if(lAve > 32767) lAve = 32767;
			else if(lAve < -32768) lAve = -32768;
			
			//
			psDst[nPos] = (short)lAve;
		}
	}
	//̂܂܎ĝH
	else
	{
		//̓f[^̂܂܎g
		memcpy(p16kHzData,pBufferIn,lSrcDataSize);
	}			
	
#ifndef PCM_TEST

	//1t[PʂŃfR[hł悤ɁA
	//f[^𕪊ăGR[h܂
	long lSize   = lDstDataSize;
	BYTE *p16kHz = p16kHzData;
	ADPCM_Size   = 0;

	//O̖GR[h
	if(m_lWorkUse > 0)
	{
		if(lSize >= (PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE - m_lWorkUse))
		{
			//̃f[^ȂāA1t[ADPCMɃGR[h
			
			//f[^A
			memcpy(m_abyWork + m_lWorkUse,p16kHz,
				   (PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE - m_lWorkUse));
			lSize -= (PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE - m_lWorkUse);

			//GR[h
			encode(pBufferOut,(short*)m_abyWork,PIECE_MOVIE_AUDIO_DATA_SIZE);
			ADPCM_Size = PIECE_MOVIE_AUDIO_DATA_SIZE;

			//|C^
			p16kHz += (PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE - m_lWorkUse);
			p16kHz -= PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE;

			//GR[hNA
			memset(m_abyWork,0,sizeof(m_abyWork));
			m_lWorkUse = 0;			
		}
		else
		{
			//̃f[^GR[hƂĕۑ
			memcpy(m_abyWork + m_lWorkUse,p16kHzData,lSize);
			m_lWorkUse += lSize;
			lSize = 0;
		}
	}
	
	//ϊf[^͂邩H
	if(lSize > 0)
	{
		//1t[GR[h
		while(lSize >= PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE)
		{
			//GR[h
			encode(pBufferOut + ADPCM_Size,(short*)(p16kHz + ADPCM_Size * 4),
				   PIECE_MOVIE_AUDIO_DATA_SIZE);
			ADPCM_Size += PIECE_MOVIE_AUDIO_DATA_SIZE;

			lSize -= PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE;
		}

		//܂肪oH
		if(lSize > 0)
		{
			//GR[hƂĕۑ
			memcpy(m_abyWork,p16kHz + ADPCM_Size * 4,lSize);
			m_lWorkUse = lSize;
		}
	}
    
#else
	
	//ADPCMɕϊĂ܂PCMɖ߂

	BYTE *pWork = new BYTE[lDstDataSize];
	ADPCM_Size = ((lDstDataSize + 3) / 4);
	
	//ADPCMɕϊ
	encode(pWork,(short*)p16kHzData,ADPCM_Size + 1);
    
	//PCMɕϊ
	decode((short*)pBufferOut,pWork,ADPCM_Size + 1);
    
	delete[] pWork;

#endif	//PCM_TEST

	//mۂobt@폜
	delete[] p16kHzData;

	//̃f[^̎Rs[
	REFERENCE_TIME TimeStart, TimeEnd;

    if(pIn->GetTime(&TimeStart, &TimeEnd) == NOERROR)
    {
        pOut->SetTime(&TimeStart, &TimeEnd);
    }

    LONGLONG MediaStart, MediaEnd;
    if(pIn->GetMediaTime(&MediaStart,&MediaEnd) == NOERROR)
    {
        pOut->SetMediaTime(&MediaStart,&MediaEnd);
    }

#ifndef PCM_TEST

	//ϊ̗Lf[^TCYZbg
    pOut->SetActualDataLength(ADPCM_Size);
   	
#else

	//ϊ̗Lf[^TCYZbg
    pOut->SetActualDataLength(lDstDataSize);
   	
#endif	//PCM_TEST

    return S_OK;
}
//---------------------------------------------------------------------------
