#pragma once

#include "..\\lib\\PMF_Header.h"
//---------------------------------------------------------------------------
// CLSID` 
//---------------------------------------------------------------------------

// {5AA199C0-DF0F-4eba-9288-6FB8F939E33D}
DEFINE_GUID(CLSID_PieceADPCMConv, 
0x5aa199c0, 0xdf0f, 0x4eba, 0x92, 0x88, 0x6f, 0xb8, 0xf9, 0x39, 0xe3, 0x3d);

//---------------------------------------------------------------------------
// 萔 
//---------------------------------------------------------------------------
#define PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE	(PIECE_MOVIE_AUDIO_DATA_SIZE * 4)

//---------------------------------------------------------------------------
// tB^NX` 
//---------------------------------------------------------------------------
class CPieceADPCMConv : public CTransformFilter
{
protected:

	unsigned char m_abyWork[PIECE_MOVIE_AUDIO_DATA_WAVE_SIZE];
	int  m_lWorkUse;

	//ȍ
	void InitMember(void);
	
	HRESULT MediaCheck(const CMediaType *MediaType);
	
	//͂ꂽf[^̃TvOg擾
	DWORD GetInputSamplePerSec(void);

	//16kHzϊɕKvȃobt@TCY擾
	long Get16kHzBuffer(long lDataSize);
	
public:

	DECLARE_IUNKNOWN;
    static CUnknown * WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);

	HRESULT CheckInputType(const CMediaType *mtIn);
    HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
	HRESULT DecideBufferSize(IMemAllocator *pAlloc,
                             ALLOCATOR_PROPERTIES *pProp);
	HRESULT CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin);
	HRESULT Transform(IMediaSample *pIn, IMediaSample *pOut);
   
	HRESULT StartStreaming();
    
	CPieceADPCMConv(void);
	~CPieceADPCMConv(void);
};

