#pragma once

#include "IPieceGrayConv.h"			//2005/07/27 Added by Madoka

#define GAMMA_VALUE			(0.85)	//K}␳l(߂̂Ɨ})

//---------------------------------------------------------------------------
// CLSID` 
//---------------------------------------------------------------------------

// {E90ACAD1-3C09-4d6f-BAB8-D79F11570EFD}
DEFINE_GUID(CLSID_PieceGrayConv, 
0xe90acad1, 0x3c09, 0x4d6f, 0xba, 0xb8, 0xd7, 0x9f, 0x11, 0x57, 0xe, 0xfd);

//---------------------------------------------------------------------------
// \ 
//---------------------------------------------------------------------------

typedef struct tag_RGB32_type
{
	BYTE B,G,R;
	BYTE Dummy;	

} RGB32_TYPE , *LPRGB32_TYPE;
//2005/07/31 Canged by Madoka
//DummyBGȐԂtccorz
//Ȃ(j-j
//ŃOCXP[ϊlɂȂ܂B

//---------------------------------------------------------------------------
// tB^NX` 
//---------------------------------------------------------------------------
class CPieceGrayConv : public CTransformFilter,public IPieceGrayConv
{
protected:

	HDC		m_hMemDC;				//DC(XN[݊)
	BYTE   *m_pbyDIB;				//Ɨp[NDIBւ̃|C^(RGB32)
    SIZE    m_tWorkSize;			//Ɨp[NDIB̃TCY
	SIZE	m_tPixelSize;			//k摜PsNŽ摜̗̈TCY
	HBITMAP	m_hOldBitmap;			//BMP̃nh
	BYTE   *m_pbyGrayDIB;			//P/ECEʃTCỸOCXP[DIBւ̃|C^(8bit)			//2005/07/24 Added by Madoka
	BOOL    m_bAutoContrast;		//RgXgtO(TRUE:RgXgs)	//2005/07/24 Added by Madoka
	BYTE   *m_pabyGammaTable;		//K}␳e[u											//2005/07/26 Added by Madoka
	BOOL    m_bGammaCorrect;		//K}␳tO(TRUE:K}␳ON)							//2005/07/26 Added by Madoka

	CCritSec m_AutoContrastLock;	//tOrpNeBJZNVIuWFNg		//2005/07/27 Added by Madoka
	CCritSec m_GammaCorrectLock;	//tOrpNeBJZNVIuWFNg		//2005/07/27 Added by Madoka

	//ő񐔂߂
	int gcd(int m,int n);

	//ŏ{߂
	int lcm(int m,int n);

	//ȍ
	void InitMember(void);

	//[NC[W̍쐬
	BOOL CreateWorkImage(BITMAPINFOHEADER *pInHeader);

	//[NC[W̍폜
	void DeleteWorkImage(void);

	//2005/07/24 Added by Madoka
	//P/ECEʃTCỸOCXP[[N쐬
	BOOL CreateGrayWorkImage(void);

	//2005/07/24 Added by Madoka
	//P/ECEʃTCỸOCXP[[N폜
	void DeleteGrayWorkImage(void);

	//2005/07/26 Added by Madoka
	//K}␳e[u쐬
	BOOL CreateGammaTable(double dGamma);

	//2005/07/26 Added by Madoka
	//K}␳e[u폜
	void DeleteGammaTable(void);

	//C[Wϊ̃RA
	DWORD EncodeFrame(BITMAPINFOHEADER *pInHeader,RGB32_TYPE *pInBuff,BYTE *pOutBuff);

	//RGBPxlɕϊ
	inline int ConvRGBtoY(double dR,double dG,double dB);

	HRESULT MediaCheck(const CMediaType *MediaType);
	
	
public:

	DECLARE_IUNKNOWN;
    static CUnknown * WINAPI CreateInstance(LPUNKNOWN punk, HRESULT *phr);

	//2005/07/27 Added by Madoka
	//AvP[VQueryInterfaceɉׂ̃I[o[Ch
	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void ** ppv);

	//2005/07/27 Added by Madoka
	//PieceGrayConvp̃C^[tF[X
	STDMETHODIMP get_AutoContrastFlag(BOOL *pbAutoContrast);	//RgXgtO擾
    STDMETHODIMP put_AutoContrastFlag(BOOL bAutoContrast);		//RgXgtOݒ
	STDMETHODIMP get_GammaCorrectFlag(BOOL *pbGammaCorrect);	//K}␳tO擾
    STDMETHODIMP put_GammaCorrectFlag(BOOL bGammaCorrect);		//K}␳tOݒ
    
	HRESULT CheckInputType(const CMediaType *mtIn);
    HRESULT GetMediaType(int iPosition, CMediaType *pMediaType);
	HRESULT CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut);
	HRESULT DecideBufferSize(IMemAllocator *pAlloc,
                             ALLOCATOR_PROPERTIES *pProp);
	HRESULT CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin);
	HRESULT Transform(IMediaSample *pIn, IMediaSample *pOut);
   
	//2005/07/24 Added by Madoka
	BOOL GetAutoContrastFlag(void) { return m_bAutoContrast; }
	void SetAutoContrastFlag(BOOL bFlag) { m_bAutoContrast = bFlag; }

	CPieceGrayConv(void);
	~CPieceGrayConv(void);
};

