//P/ECE Movie File wb_
//

//---------------------------------------------------------------------------
#ifndef _PMF_H_
#define _PMF_H_
//---------------------------------------------------------------------------

//P/ECẼZN^TCY
#define PIECE_SECTOR_SIZE	(4096)

//P/ECẼXN[
#define PIECE_SCREEN_WIDTH	(128)
#define PIECE_SCREEN_HEIGHT	(88)

//P/ECE Movie Filȅ
#define PIECE_MOVIE_FILE_EXT			"pmf"		//gq

#define PIECE_MOVIE_COLOR_DEPTH_BIT		(4)			//F̃rbg
#define PIECE_MOVIE_FRAME_HEADER_SIZE	(2)			//PMF Framewb_̃TCY
#define PIECE_MOVIE_VIDEO_SIZE_MASK		(0x1FFF)	//Videõf[^TCY}XN
													//t[wb_ɂ̃}XNAND
													//Videõf[^TCY܂
#define PIECE_MOVIE_VIDEO_SAME_MASK		(0x8000)	//Õt[ƑStÕ}XN
#define PIECE_MOVIE_VIDEO_KEY_THRESHOLD	(5632)		//L[t[Ƃ臒l(Õt[ƈႤsNZ̐)
#define PIECE_MOVIE_VIDEO_KEY_MASK		(0x4000)	//L[t[tÕ}XN
#define PIECE_MOVIE_VIDEO_KEY_CYCLE		(225)		//L[t[
#define PIECE_MOVIE_VIDEO_DATA_MAXSIZE	((PIECE_SCREEN_WIDTH  *           \
	                                      PIECE_SCREEN_HEIGHT *           \
                                          PIECE_MOVIE_COLOR_DEPTH_BIT / 8 \
                                         ))			//PMF Videof[^̍őTCY
#define PIECE_MOVIE_AUDIO_USE_MASK		(0x2000)	//AudioptÕ}XN
#define PIECE_MOVIE_AUDIO_DATA_SIZE		(512)		//Audiof[^̃TCY(Œ)
													//P/ECEpADPCM(16kHz 4bit)Ȃ̂ŁA
													//1t[̉f[^̃TCY
													//15.625fps(64ms)p = 0.064 * 16000 * 4 = 4096[bits] = 512[bytes]
													//Đ16msPʂłȂƃLCɖȂ
                                                    //̊֌WVideoɍ킹16.625fps
                                                    //ƂĂ܂B

//PMFt@Cwb_VOl`
#ifdef PIECE
	#define PMF_FCC_V1	(0x31464D50)	//'PMF1'
	#define PMF_FCC		(0x32464D50)	//'PMF2'
#else
	#define PMF_FCC_V1	'PMF1'
	#define PMF_FCC		'PMF2'
#endif

//PMFt@Cwb_\
typedef struct tag_PMF_File_Header_Type_V1	//o[W
{
	DWORD	dwSignature;		//ʎq dwSignature = 'PMF1'
	WORD	wfix8FPS;			//[r[̃t[(8:8̌Œ菬)
                                //݂15.625 * 256 = 4000 = 0x0FA0Œ 
    WORD    wAudioDataSize;		//et[Audiof[^TCY
	DWORD   dwTotalFrames;		//t[
	DWORD	dwReserve;			//\(K0ɂĂ)	
} PMF_FILE_HEADER_TYPE_V1;

typedef struct tag_PMF_File_Header_Type
{
	DWORD	dwSignature;		//ʎq dwSignature = 'PMF2'
	WORD	wfix8FPS;			//[r[̃t[(8:8̌Œ菬)
                                //݂15.625 * 256 = 4000 = 0x0FA0Œ 
    WORD    wAudioDataSize;		//et[Audiof[^TCY
	DWORD   dwTotalFrames;		//t[
	DWORD	dwOffsetForKeyList;	//̍\̂̐擪|C^L[t[
								//ItZbgXgwb_܂ł̃ItZbgoCg
} PMF_FILE_HEADER_TYPE;

#define PMF_FILE_HEADER_SIZE	(16)	//PMFt@Cwb_\̂̃TCY(dv)

//#define PMF_FPS			   (15.625)	//PMFt@CFPS(Videot[Đ[g)
//#define PMF_FPS_FIXED		   (0x0FA0)	//15.625fps * 256 = 4000 = 0x0FA0
//[Aς15.62510炢ĐƂ񂾂rfI̍Đx
//̂ŁAƒBǂzȌԂ݂łˁB
//قƂ́Aƕ`揈ɂ鎞Ԃ͌v肵ĒׂāAK؂ȃt[[g
//ZôǂłAƂ肠vOȂ̂ŁAōς܂Ă܂B
//悢q͐^Ⴞ߂(^^;

//#define PMF_FPS			   (15.613)	//PMFt@CFPS(Videot[Đ[g)
//#define PMF_FPS_FIXED		   (0x0F9D)	//15.613fps * 256 = 3996.928  3997 = 0x0F9D
//2005/07/08 Changed by Madoka 30𒴂铮ł͌㔼ς肸Ă̂ŁA
//                             ƔFPS𒲐
#define PMF_FPS				   (15.610)	//PMFt@CFPS(Videot[Đ[g)
#define PMF_FPS_FIXED		   (0x0F9C)	//15.610fps * 256 = 3996.16  3996 = 0x0F9C

//t[wb_̓e
//[Frame Header]
//   
//   et[f[^̐擪ɂ2oCg̃wb_񂪕t܂B
//   f[^͈̓ȉ̒ʂB
//
//   MSB                        LSB
//   +--------+-------+-----------+
//   |15 -- 14|  13   |12 ------ 0|
//   +--------+-------+-----------+
//   |  Video | Use   | Video Bit |
//   |  Frame | Audio | Stream    |
//   |  Flag  | Flag  | Size      |
//   +--------+-------+-----------+
//
//   wb_ɂ͉13bitVideof[^̃rbgXg[̃TCYA
//   3bit͊etOɗpB
//
//   b15`b14 Videot[tO
//            (00:ʏ̈kt[(ksNZƔ񈳏ksNZ̍)
//             01:L[t[(SsNZ񈳏k)
//             10:Õt[ƑS(f[^FSsNZk)
//             11:`)
//   b13      AudioptO(0:Audiof[^Ȃ 1:Audiof[^)
//   b12`b0  Videof[^̃TCY(oCgP)
//            L[t[̎́A128*88/4 = 5632 ܂B
//            Õt[ƑSꍇ0܂B
//            Ȃ݂ɁAAudiof[^PMF FileHeaderŎwB
//

//'PMF2'ǉ
//L[t[̂ZN^Ƃ̃ItZbg
//(܂B̍\̂ŏ`N\ɂ΂悩
// ĈAȂ̂ŁAƂ肠VOl`
// tƂ܂B[A݌vs(j-j)

//L[t[Xgwb_VOl`
#ifdef PIECE
	#define KLH_FCC		(0x31484C4B)	//'KLH1'
#else
	#define KLH_FCC		'KLH1'
#endif

#ifdef WIN32
#pragma pack(1)
#endif //WIn32

//L[t[ItZbg\
//L[t[Xgɂ͂̃ItZbg\̂т܂
typedef struct tag_PMF_Key_Frame_Offset_Info_Type
{
	DWORD dwSector;				//̃L[t[f[^ւ
								//t@C擪̃ZN^
								//ZN^P/ECE4096oCgP
	
	DWORD dwOffsetBytes;		//wZN^ł̃ItZbg(oCgP < 4096)
	
} PMF_KEY_FRAME_OFFSET_INFO_TYPE;

//L[t[Xgwb_\
typedef struct tag_PMF_Key_List_Header_Type
{
	DWORD dwSignature;			//ʎq dwSignature = 'KLH1'
	long  lKeyFrames;			//L[t[(PIECE_MOVIE_VIDEO_KEY_CYCLEŐ)
	
	PMF_KEY_FRAME_OFFSET_INFO_TYPE
	 atKeyFrameList[1];			//L[t[ItZbgz([1]̓_~[Ŏۂ͂ς)
	 
} PMF_KEY_LIST_HEADER_TYPE;	

#ifdef WIN32
#pragma pack()
#endif //WIn32

#define PMF_KEY_LIST_HEADER_INFO_SIZE	(8)	//L[t[Xgwb_̃TCY(dv)
#define PMF_KEY_FRAME_OFFSET_INFO_SIZE	(8)	//L[t[ItZbg̃TCY(dv)


//---------------------------------------------------------------------------
#endif	//_PMF_H_
//---------------------------------------------------------------------------
