#include <s1c33cpu.h>
#include <string.h>
#include <stdio.h>
#include <piece.h>
#include "mmc_api.h"

#define PDWAIT	(*(volatile unsigned char*)0x1000000)	/* p[_Ê߂̃EFCg̈ */
#define P0D	(*(volatile unsigned char*)0x00402D1)	/* P0o͌p|[gf[^WX^ */

/* NbNLoM̃EFCg(1KvA0ł̓G[) */
#define WAIT1 do {	\
	*pdwait = 0;	\
} while(0)

/* NbNHiM̃EFCg(5KvA4ł̓G[) */
#define WAIT5 do {	\
	*pdwait = 0;	\
	*pdwait = 0;	\
	*pdwait = 0;	\
	*pdwait = 0;	\
	*pdwait = 0;	\
} while(0)


//---------------------------------------------------------------------------

int
mmcWaitStartBit(void)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	//const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int i;

	/* X^[grbg(0)܂ő҂B */
	i = MMC_RECV_TIMEOUT;
	for(;;) {

		/* NbNLowɁB(P06Low) */
		*p0d = lo1;
		WAIT1; /* EFCg1ȏKv */

		/* NbNHighɁB(P06High) */
		*p0d = hi1;
		WAIT5; /* EFCg5ȏKv */

		/* f[^擾(P04f[^擾)B */
		if(!(*p0d & 0x10)) {
			break; /* X^[grbg(0)o */
		}

		/* ^CAEg0ԂB */
		if(!--i) {
			return 0;
		}
	}

	return 1;
}

//---------------------------------------------------------------------------

int
mmcWaitBusy(void)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	//const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int i;

	/* X^[grbg(0)܂ő҂B */
	i = MMC_RECV_TIMEOUT;
	for(;;) {

		/* NbNLowɁB(P06Low) */
		*p0d = lo1;
		WAIT1; /* EFCg1ȏKv */

		/* NbNHighɁB(P06High) */
		*p0d = hi1;
		WAIT5; /* EFCg5ȏKv */

		/* f[^擾(P04f[^擾)B */
		if(*p0d & 0x10) {
			break; /* rW[(1)o */

		}

		/* ^CAEg0ԂB */
		if(!--i) {
			return 0;
		}
	}

	return 1;
}

//---------------------------------------------------------------------------

unsigned char
mmcByteRecv(void)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	//const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int v = 0;

	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x80;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x40;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x20;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x10;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x08;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x04;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x02;
	*p0d = lo1; WAIT1; *p0d = hi1; WAIT5; if(*p0d & 0x10) v |= 0x01;

	return v;
}

//---------------------------------------------------------------------------

void
mmcByteSend(int data)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;

	/* f[^A]ȊOł̃oCgM_~[NbNḾAEFCgKv݂łB */
	if(data & 0x80) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x40) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x20) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x10) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x08) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x04) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x02) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
	if(data & 0x01) { *p0d = lo1; WAIT1; *p0d = hi1; WAIT5; } else { *p0d = lo0; WAIT1; *p0d = hi0; WAIT5; }
}

//---------------------------------------------------------------------------

int
mmcRecvData(unsigned char* buf, int len)
{
	volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	//const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int v;
	int i;

	/* 0oCgMv͕sȃNGXgłB */
	if(len <= 0) {
		return 0;
	}

	/* X^[grbg(0)܂ő҂B */
	i = MMC_RECV_TIMEOUT;
	for(;;) {

		/* NbNLowɁB(P06Low) */
		*p0d = lo1;
		WAIT1; /* EFCg1ȏKv */

		/* NbNHighɁB(P06High) */
		*p0d = hi1;
		WAIT5; /* EFCg5ȏKv */

		/* f[^擾(P04f[^擾)B */
		if(!(*p0d & 0x10)) {
			break; /* X^[grbg(0)o */
		}

		/* ^CAEg0ԂB */
		if(!--i) {
			return 0;
		}
	}

	/* R1 or R2X|XMH */
	if(len <= 2) {
		/* 1rbgMς݂ɁB */
		v = 0;
		goto R1_R2;
	}

	/* ̃f[^MB */
	do {
		/* 1oCg=8rbg̃f[^M܂B
		 * Ȃ̓NbNLowAHǐ̃EFCgłlMł܂B
		 * f[^]n܂AMMC̕GȏȂ邩ł傤H
		 */
		v = 0;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x80;
R1_R2:		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x40;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x20;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x10;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x08;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x04;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x02;
		*p0d = lo1; *p0d = hi1; if(*p0d & 0x10) v |= 0x01;
		*buf++ = v;

	} while(--len);

	return 1;
}

//---------------------------------------------------------------------------

int
mmcSendData(const unsigned char *paSendBuff,int iSendLen)
{
	//volatile unsigned char* const pdwait = &PDWAIT;
	volatile unsigned char* const p0d = &P0D;
	//
	const int lo0 = *p0d & ~0x60;
	const int lo1 = lo0 | 0x20;
	const int hi0 = lo0 | 0x40;
	const int hi1 = lo0 | 0x60;
	//
	int data;

	if(iSendLen <= 0) {
		return 0;
	}

	do {
		data = *paSendBuff++;

		/* f[^A]̓EFCgőv݂łB
		 * ̑AƂǂBusyNAxȂ݂łB
		 * Ԃ񂻂̂ƂAtbV̏sĂ̂Ǝv܂B
		 * ^CAEg͏߂ɎĂB
		 */
		if(data & 0x80) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x40) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x20) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x10) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x08) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x04) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x02) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }
		if(data & 0x01) { *p0d = lo1; *p0d = hi1; } else { *p0d = lo0; *p0d = hi0; }

	} while(--iSendLen);

	return 1;
}
//---------------------------------------------------------------------------
void mmcSendDataCore(unsigned char *paData,int iDataLen)
{

	//f[^̑MRA
	
	//_~[NbN𑗂ȂMMCŐFX
	//ĂȂȂ̂Œ
	int i;
	
	//8NbÑ_~[M
	mmcByteSend(0xFF);
	
	//w̃oCgf[^𑗐M
	for(i = 0;i < iDataLen;++i)
	{
		//PoCgM
		mmcByteSend(*paData++);
	}

	//8NbÑ_~[M
	mmcByteSend(0xFF);

}
//---------------------------------------------------------------------------
unsigned short mmcSendCommandAndRecvResponse(unsigned char ucCMD,unsigned long ulArg)
{

	//R}hMX|XM
	//CMD13R2X|X(2bytes)
	unsigned short usRes = 0xFFFF;		//X|X
	unsigned char ucWork;				//ꎞL
	unsigned char ucaCommand[6];		//R}hf[^
	//int i;

	//R}hf[^̍쐬

	//R}hZbg
	ucaCommand[0] = (0x40 | ucCMD);
	
	//Zbg
	//for(i = 4;i > 0;--i)
	//{
	//	ucaCommand[i] = (unsigned char)(ulArg & 0xFF);
	//	ulArg >>= 8;
	//}
	//2005/02/09 Change by Madoka ł邽߁Ax^ŏ܂
	{	
		ucaCommand[4] = (unsigned char)(ulArg & 0xFF);
		ulArg >>= 8;
		ucaCommand[3] = (unsigned char)(ulArg & 0xFF);
		ulArg >>= 8;
		ucaCommand[2] = (unsigned char)(ulArg & 0xFF);
		ulArg >>= 8;
		ucaCommand[1] = (unsigned char)(ulArg       );
	}	

	//CRCZbg
	ucaCommand[5] = 0xFF;	//_~[

	//R}hM
	mmcSendDataCore(ucaCommand,6);

	//X|XM
	if(mmcRecvData(&ucWork,1) == 1)
	{
		//X|X擾
		usRes = ucWork;

		//̂CMD13H
		if(ucCMD == 13)
		{
			//̂ʂɂ炷
			usRes <<= 8;

			//c1oCgM
			if(mmcRecvData(&ucWork,1) == 1)
			{
				
				usRes |= (unsigned short)ucWork;

			}
			else usRes = 0xFFFF;	//s
		}
	}

	return usRes;

}
//---------------------------------------------------------------------------
