//---------------------------------------------------------------------------
// P/ECE Movie File Player 
//
// RAMɒufR[hRA[`
//
// 2004/11/07          by Madoka 쐬Jn
// 2005/06/13		   by Madoka PAD̍EŃV[N\
// 2005/08/08          by Madoka PMF2ɂăf[^̏I[`FbN
//                               ԈĂ̂C
//
// H    P:http://www2.plala.or.jp/madoka/
//        http://www2.plala.or.jp/madoka/Piece_ele/pmf/pmf.htm
// E-mail:madoka@olive.plala.or.jp
//
// ^u4ŌĂ
//---------------------------------------------------------------------------
// t@CCN[h 
//---------------------------------------------------------------------------
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"
#include "clippce.h"
#include "mmc_api.h"
#include "pmf_player.h"
#include "..\\lib\\PMF_Header.h"

//---------------------------------------------------------------------------
// 萔}N` 
//---------------------------------------------------------------------------
#define NEXT_BYTE  do{ ucData = *pucBuff; pucBuff += 1; usLoop += 1; ucBits = 0; } while(0)
#define CHECK_8BIT do{ if(ucBits == 8){ ucData = *pucBuff; pucBuff += 1; usLoop += 1; ucBits = 0; } }while(0)
#define NEXT_BIT   do{ ucData <<= 1; ucBits += 1; }while(0) 

#define LCD_BRIGHT_MAX		(63)
#define AUDIO_VOLUME_MAX	(127)	

//---------------------------------------------------------------------------
// O[oϐ` 
//---------------------------------------------------------------------------
extern unsigned char g_aaaucFbuff[FRAME_BUFF_NUM][FRAME_DIV_NUM][FRAME_DATA_SIZE];	//Videot[obt@
extern unsigned char g_aaucAudio[FRAME_BUFF_NUM][PIECE_MOVIE_AUDIO_DATA_SIZE];		//Audiot[obt@
extern unsigned char g_aucData[SCT_SIZE];											//ǂݍ݃[Nobt@

extern PCEWAVEINFO g_atWaveInfo[FRAME_BUFF_NUM];	//f[^

unsigned short g_usReaded;							//[Nobt@̏σf[^	
unsigned short g_usReadMax;							//[Nobt@̗Lf[^
unsigned long  g_ulSct;								//݂̃ZN^ʒu
unsigned long  g_ulMovieDataEnd;					//gp铮f[^̏I[(t@C擪̃oCg)	//2005/08/08 Added by Madoka

extern FILEACC	g_tFileAcc;		
								
volatile unsigned char g_ucDrawFrame;				//\t[CfbNX(Oobt@)
unsigned char g_ucLoadFrame;						//ǂݍ݃t[(Oobt@)
unsigned char g_ucEOF;								//ŏIt[̃CfbNX(Oobt@)
unsigned long g_ulNowFrame;							//Đ̃t[
volatile unsigned char g_ucFreeBuffCnt;				//󂫃obt@JE^
volatile unsigned char g_ucCnt;						//K\t[JE^

extern volatile unsigned char g_ucPause;			//ꎞ~tO(0Œ~)
extern PMF_FILE_HEADER_TYPE g_tPMF_Header;			//PMFt@Cwb_
extern unsigned char g_ucSeekEnable;				//V[NLtO(0:V[Ns(PMF1) 1:V[N\(PMF2ȍ~))	//2005/06/12 Added by Madoka

unsigned short g_usColorTbl1[COLOR_DEPTH][FRAME_DIV_NUM];	//1sNZpJ[e[u
unsigned short g_usColorTbl2[COLOR_DEPTH][FRAME_DIV_NUM];	//2sNZpJ[e[u

//---------------------------------------------------------------------------
void InitWaveInfo(void);
void SeekLoop(long pad);
//---------------------------------------------------------------------------
unsigned char* GetNextBuff(void)
{
	//̃obt@擾

	g_usReadMax = FileReadSct(&g_tFileAcc,g_aucData,g_ulSct,SCT_SIZE);
	g_usReaded = 0;

	g_ulSct++;

	return g_aucData;
}
//---------------------------------------------------------------------------
void GetNextFrameData(void)
{
	//̃t[f[^擾

	unsigned char *pucBuff = g_aucData + g_usReaded;
	unsigned short usFrameHeader;
	unsigned char ucData;
	unsigned char ucLoadFrame = g_ucLoadFrame;
	unsigned char ucPrevFrame;
	unsigned short *pusFrameBuff;
	

	//t[wb_擾

	//t[wb_܂ǂ߂邩H
	if((g_usReadMax - g_usReaded) >= 2)
	{
		//擾
		usFrameHeader = (*pucBuff) | (*(pucBuff + 1) << 8);

		//i߂
		g_usReaded += 2;
		pucBuff     += 2;

		//obt@ǂ݂H
		if(g_usReaded == g_usReadMax)
		{
			//̃obt@擾
			pucBuff = GetNextBuff();
		}
	}
	else
	{
		//ŏ1oCg擾
		usFrameHeader = *pucBuff;

		//̃obt@擾
		//g_lReadMaxg_lReaded̓Zbg
		pucBuff = GetNextBuff();

		//1oCg擾
		usFrameHeader |= ((*pucBuff) << 8);

		//i߂
		g_usReaded  = 1;
		pucBuff     += 1;
	}	

	//Video̓WJ
	
	//L[t[H
	if(usFrameHeader & PIECE_MOVIE_VIDEO_KEY_MASK)
	{
		//2sNZ擾
		unsigned short usIndex = 0;
		unsigned short usLoop,usLoopMax;
		unsigned char  ucCnt,ucCntMax,x,y;
		unsigned short *pusColorTbl1,*pusColorTbl2;
		unsigned char  ucColor1,ucColor2;
		int nOffset,nShift;
		unsigned short usMask;
		unsigned short *pusDst;	
		
		//O[oϐꎞIɃ[Jϐň	̂̕
		pusFrameBuff  = (unsigned short*)g_aaaucFbuff[ucLoadFrame];
		
		//obt@̎ceʂŏ𕪂񐔂Zo
		usLoopMax = g_usReadMax - g_usReaded;
		if(usLoopMax < (FRAME_PIXEL_MAX_HALF - SCT_SIZE)) ucCntMax = 3;
		else ucCntMax = 2;
		ucCnt = 0;

		for(;;)
		{
			for(usLoop = 0;usLoop < usLoopMax;++usLoop)
			{
				//2sNZf[^擾
				
				//LCDf[^Zbg
				//2sNZ̃J[f[^CɃZbg
				x = (unsigned char)(usIndex & 0x7F);
				y = (unsigned char)(usIndex >> 7);
				ucColor1 = *pucBuff & 0x0F;
				ucColor2 = *pucBuff >> 4;
				nOffset  = (88 * (x >> 3) + y); 
				nShift   = (x & 0x07);
				usMask   = ~(0x0303 << nShift);
				
				pusDst       = pusFrameBuff + nOffset;
				pusColorTbl1 = g_usColorTbl1[ucColor2];
				pusColorTbl2 = g_usColorTbl2[ucColor1];
								
				*pusDst = (*pusDst & usMask) | ((*(pusColorTbl2    ) | *(pusColorTbl1    )) << nShift);
				pusDst += FRAME_DATA_SIZE_HALF;
				*pusDst = (*pusDst & usMask) | ((*(pusColorTbl2 + 1) | *(pusColorTbl1 + 1)) << nShift);
				pusDst += FRAME_DATA_SIZE_HALF;
				*pusDst = (*pusDst & usMask) | ((*(pusColorTbl2 + 2) | *(pusColorTbl1 + 2)) << nShift);
				pusDst += FRAME_DATA_SIZE_HALF;
				*pusDst = (*pusDst & usMask) | ((*(pusColorTbl2 + 3) | *(pusColorTbl1 + 3)) << nShift);

				//|C^i߂
				pucBuff  += 1;

				//̃sNZ
				usIndex += 2;
			}

			//[vJE^XV
			ucCnt += 1;

			//I
			if(ucCnt == ucCntMax)
				break;

			//̃[ṽf[^Zo
			usLoopMax = (FRAME_PIXEL_MAX - usIndex) >> 1;
			if(usLoopMax > SCT_SIZE) usLoopMax = SCT_SIZE;

			//̃obt@擾
			g_usReadMax = FileReadSct(&g_tFileAcc,g_aucData,g_ulSct,SCT_SIZE);
			g_usReaded  = usLoopMax; 	
			g_ulSct++;
			pucBuff = g_aucData;
		}
	}
	else
	{
		//Ƃ肠Õt[ۂƃRs[
		ucPrevFrame = (ucLoadFrame == 0) ? (FRAME_BUFF_NUM - 1) : (ucLoadFrame - 1);

		memcpy(g_aaaucFbuff[ucLoadFrame],
			   g_aaaucFbuff[ucPrevFrame],
			   FRAME_PIXEL_MAX);

		//Õt[ƑSȂH
		if(!(usFrameHeader & PIECE_MOVIE_VIDEO_SAME_MASK))
		{
			//1bitmFĂ
			unsigned short usVideoSize;
			unsigned short usIndex = 0;	//ݐCfbNX
			unsigned char  ucBits  = 0;	//rbg			
			unsigned short *pusColorTbl;
			unsigned char  ucColor;
			unsigned short usLoop,usLoopMax;
			unsigned char  ucCnt,ucCntMax,x,y;
			int nOffset,nShift;
			unsigned short usMask;
			unsigned short *pusDst;	
			
			//VideoTCY̎擾
			usVideoSize = usFrameHeader & PIECE_MOVIE_VIDEO_SIZE_MASK;
	
			//O[oϐꎞIɃ[Jϐň	̂̕
			pusFrameBuff  = (unsigned short*)g_aaaucFbuff[ucLoadFrame];
		
			//obt@̎ceʂŏ𕪂񐔂Zo
			usLoopMax = g_usReadMax - g_usReaded;
			if(usVideoSize <= usLoopMax)	
			{
				ucCntMax = 0;
				usLoopMax = usVideoSize;
				g_usReaded += usLoopMax;
			}
			else ucCntMax = (unsigned char)(1 + ((usVideoSize - usLoopMax) >> SCT_SHIFT));
			usVideoSize -= usLoopMax;
			ucCnt = 0;
			
			//ŏ̃f[^擾
			ucData = *pucBuff;
			pucBuff += 1;
			usLoop = 1;
			
			for(;;)
			{
				do
				{
					//krbgH
					if((ucData & 0x80))
					{
						//̃rbg
						NEXT_BIT;
						CHECK_8BIT;
					}
					else
					{
						//kĂȂ̂ŁA4bit
						//VsNZlƂėp
						//(قƂucBit̒l̏oƂl
						// ̏Ԃς̂ǂƎv܂
						// AƂ肠͏ԂۂׂĂ܂(^^;)	

						if(ucBits < 3)
						{
							//ucBits3ƐΎ1oCg
							//sȂ̂ŁArCHECK_8BITȗ
							//܂BāA4rbgėLȂ
							//Ă̂ŁA1rbgɁA
							//CɎ擾܂B
							NEXT_BIT;
							ucColor = ucData >> 4;
							ucData <<= 4;
							ucBits += 4;
                		}
						else if(ucBits == 3)
						{
							//ucBits34rbgėLŁAA
							//f[^擾ɕK̃oCgɍŝ
							//Ȃȗł܂B
							NEXT_BIT;

							ucColor = ucData >> 4;
							
							NEXT_BYTE;
						}
						else if(ucBits == 7)
						{
							//ucBits7ƍŏɎ1oCgɐi
							//ƁA΂Ɏ1oCgɂ͍sȂ
							//̂ŁACHECK_8BITȗ܂B
							//܂Ȁꍇ4rbgLȂ̂
							//Ă̂ŁA1rbgɁA
							//CɎ擾܂B

							ucData   = *pucBuff;
							pucBuff += 1;
							usLoop  += 1;
							
							ucColor  = ucData >> 4;
							ucData <<= 4;
							ucBits   = 4;						
						}
						else if(ucBits == 4)
						{
							NEXT_BIT;					//ł͐Ύ1oCg
														//sȂ̂CHECK_8BIT͏ȗ
							ucColor  = 0;
							ucColor |= (ucData >> 4);
							
							NEXT_BIT;
							ucColor |= (ucData >> 5);
							
							NEXT_BIT;
							ucColor |= (ucData >> 6);
							
							NEXT_BYTE;					//ucBits == 4̎Ŏ̃oCg	
							ucColor |= (ucData >> 7);

							//̃rbg
							NEXT_BIT;

							//ȑOɕK1oCgɐił
							//̂ŁAłCHECK_8BITȗł
						}
						else if(ucBits == 5)
						{
							NEXT_BIT;					//ł͐Ύ1oCg
														//sȂ̂CHECK_8BIT͏ȗ
							ucColor  = 0;
							ucColor |= (ucData >> 4);
							
							NEXT_BIT;
							ucColor |= (ucData >> 5);
							
							NEXT_BYTE;					//ucBits == 5̎Ŏ̃oCg	
							ucColor |= (ucData >> 6);
							
							NEXT_BIT;
							ucColor |= (ucData >> 7);

							//̃rbg
							NEXT_BIT;

							//ȑOɕK1oCgɐił
							//̂ŁAłCHECK_8BITȗł
						}
						else //ucBits == 6
						{
							NEXT_BIT;					//ł͐Ύ1oCg
														//sȂ̂CHECK_8BIT͏ȗ
							ucColor  = 0;
							ucColor |= (ucData >> 4);
							
							NEXT_BYTE;					//ucBits == 6̎Ŏ̃oCg	
							ucColor |= (ucData >> 5);
							
							NEXT_BIT;
							ucColor |= (ucData >> 6);
							
							NEXT_BIT;
							ucColor |= (ucData >> 7);

							//̃rbg
							NEXT_BIT;

							//1ÔŕK1oCgɐił
							//̂ŁAłCHECK_8BITȗł
						}

						//擾VsNZlZbg
						x = (usIndex & 0x7F);
						y = (usIndex >> 7);
						nOffset = (88 * (x >> 3) + y);
						nShift  = (x & 0x07);
						usMask = ~(0x0101 << nShift);
						
						pusDst      = pusFrameBuff + nOffset;
						pusColorTbl = g_usColorTbl1[ucColor];

						*pusDst = (*pusDst & usMask) | (*(pusColorTbl + 0) << nShift);
						pusDst += FRAME_DATA_SIZE_HALF;
						*pusDst = (*pusDst & usMask) | (*(pusColorTbl + 1) << nShift);
						pusDst += FRAME_DATA_SIZE_HALF;
						*pusDst = (*pusDst & usMask) | (*(pusColorTbl + 2) << nShift);
						pusDst += FRAME_DATA_SIZE_HALF;
						*pusDst = (*pusDst & usMask) | (*(pusColorTbl + 3) << nShift);
					}

					//̃sNZ
					usIndex += 1;
		
				} while(usLoop < usLoopMax);
				usLoop = 0;

				//[vJE^XV
				ucCnt += 1;

				//I
				if(ucCnt > ucCntMax)
					break;

				//̃[ṽf[^Zo
				usLoopMax = usVideoSize;
				if(usLoopMax > SCT_SIZE) usLoopMax = SCT_SIZE;
				usVideoSize -= usLoopMax;

				//̃obt@擾
				g_usReadMax = FileReadSct(&g_tFileAcc,g_aucData,g_ulSct,SCT_SIZE);
				g_usReaded  = usLoopMax; 	
				g_ulSct++;
				pucBuff = g_aucData;					

			}

			//傤ǃZN^TCYǂł܂H
			if(g_usReaded == g_usReadMax)
			{
				//̃obt@擾
				g_usReadMax = FileReadSct(&g_tFileAcc,g_aucData,g_ulSct,SCT_SIZE);
				g_usReaded  = 0; 	
				g_ulSct++;
				pucBuff = g_aucData;					
			}
			else
                pucBuff = g_aucData + g_usReaded;					
		}
	}

	//Audio̓ǂݍ
	if(usFrameHeader & PIECE_MOVIE_AUDIO_USE_MASK)
	{
		unsigned short usRest;
		unsigned short usRead;

		//̃ZN^ǂޕKv邩H
		usRest = g_usReadMax - g_usReaded;
		if(usRest <= PIECE_MOVIE_AUDIO_DATA_SIZE)
		{
			//ŏ̕ǂ
			memcpy(g_aaucAudio[ucLoadFrame],pucBuff,usRest);
			
			//̃ZN^ǂ
			pucBuff = GetNextBuff();

			//c̕ǂ
			usRead = PIECE_MOVIE_AUDIO_DATA_SIZE - usRest;
			memcpy(g_aaucAudio[ucLoadFrame] + usRest,pucBuff,usRead);

			g_usReaded = usRead;
		}
		else
		{			
			//AUDIOf[^ǂݍ
			memcpy(g_aaucAudio[ucLoadFrame],pucBuff,PIECE_MOVIE_AUDIO_DATA_SIZE);
			
			g_usReaded += PIECE_MOVIE_AUDIO_DATA_SIZE;			
		}		
		
		//f[^̍Đݒ
		g_atWaveInfo[ucLoadFrame].len = FRAME_AUDIO_LEN;
	}

	//EOF`FbN
	if(((g_ulSct << 12) + g_usReaded) >= g_ulMovieDataEnd)
	{
		g_ucEOF = ucLoadFrame;
		g_atWaveInfo[ucLoadFrame].next = 0;	//[vI
	}
		
	//̃t[
	g_ucLoadFrame++; 
	g_ucLoadFrame %= FRAME_BUFF_NUM;

	//󂫃obt@ЂƂ
	g_ucFreeBuffCnt -= 1;
}
//---------------------------------------------------------------------------
void Play_Loop_Core(void)
{
	//Đ̃RA[v
	//
	//̃[vɓĂ܂ƈ؃VXeɐ
	//ԂȂ̂ŁAUSBʐM⎩X^oCڍs@\
	//ȂǂgȂƂɒӂĂB
	//
	//VXeɐԂȂ̂ŁAStart
	//̃j[Select & Start̋I
	//܂B
	//
	long pad;
	int lcd_bright;
	int volume;

	for(;;)
	{
		//t[f[^̎擾	
		//Đt[𒴂Ď擾Ȃ悤ɂ
		if(g_ucPause)
		{
			//obt@ɋ󂫂͂邩H
			if((g_ucFreeBuffCnt > 0) && (g_ucEOF == 0xFF))
				GetNextFrameData();
		}

		//pbhԂ̎擾
		pcePadGetProc();
		pad = pcePadGet();

		//X^[g{^ňꎞ~
		if(pad & TRG_START)
		{			
			//~̂H
			if(g_ucPause == 1)
			{
				//~
				pceWaveAbort(AUDIO_CH);
			}
			else
			{
				//񏉊
				InitWaveInfo();

				//ĊJ
				g_ucCnt = 0;
				pceWaveDataOut(AUDIO_CH,&g_atWaveInfo[g_ucDrawFrame]);
			}

			g_ucPause = 1 - g_ucPause;
		}

		//SELECT{^Ŕ
		if(pad & TRG_SELECT)
			break;	

		//AEB{^ŃRgXg
		if(pad & TRG_AB)
		{
			//݂̃RgXgl擾
			lcd_bright = pceLCDSetBright(INVALIDVAL);
			
			//A{^ŃRgXgグ
			if(pad & TRG_A)
			{
				lcd_bright += 1;
			}
			//B{^ŃRgXg
			else
			{
				lcd_bright -= 1;
			}

			//RgXg
			if(lcd_bright > LCD_BRIGHT_MAX) lcd_bright = LCD_BRIGHT_MAX;
			else if(lcd_bright < 0)         lcd_bright = 0;
			
			//VRgXglZbg
			pceLCDSetBright(lcd_bright);
		}
		//pbh̏㉺ŉʒ
		else if(pad & TRG_UD)
		{
			//݂̉(l)擾
			volume = pceWaveSetChAtt(AUDIO_CH,INVALIDVAL);

			//{^ŉʂグ
			if(pad & TRG_UP)
			{
				volume -= 1;
			}
			//{^ŉʂ
			else
			{
				volume += 1;
			}

			//ʐ
			if(volume > AUDIO_VOLUME_MAX) volume = AUDIO_VOLUME_MAX;
			else if(volume < 0)           volume = 0;
			
			//VʂZbg
			pceWaveSetChAtt(AUDIO_CH,volume);
		}
		//2005/06/13 Added by Madoka
		//pbh̍EŃV[N
		else if(pad & TRG_LR)
		{
			//V[N[v(PAUSE̓V[N)
			if((g_ucPause != 0) && (g_ucSeekEnable == 1))
				SeekLoop(pad);
		}		
	}

	//pbhԂ̎擾
	pcePadGetProc();
		
}
//---------------------------------------------------------------------------
