// PMF_Previwer.cpp : R\[ AvP[ṼGg |Cg`܂B
//
//̃vr[c[͊{IɎ蔲Ȃ̂ŁACă\[XĂ(^^;
//  񂾂fƉƂ̓ȂȂɁAg債Aɏd
//@Ƃɂ܂BӂB
//  Ȃ݂ɁAEChEANeBuɂȂĂƂ낢냁bZ[W邹
//  AȂ蓮삪xȂ邱Ƃ܂̂ŁAȂׂEChE͔ANeBu
//  ԂɂČ悤ɂĉB
//
//  ̃c[͉fƉƍĐł邩ǂ̊mFpɂc[Ȃ̂ŁA
//  Ɖf̓܂ł͂܂ŋCĂ܂B
//  C獂Ă݂悤Ǝv܂AƗD揇ʂ͒ႢB
//  CP/ECEł̍ĐȂ̂ŁAPMFP/ECEły݉(^^;
//
#include "stdafx.h"
#include "PMF_Previwer.h"
#include "..\\lib\\PMF_Header.h"
#include <deque>

#pragma comment(lib,"winmm.lib")

#define MAX_LOADSTRING 100

//---------------------------------------------------------------------------
// 萔\ 
//---------------------------------------------------------------------------
#define PCE_GRAYSCALE_DEPTH	(13)	//P/ECȆK\̐[x(K)

//Kpbg
RGBQUAD g_atPalette[PCE_GRAYSCALE_DEPTH] = 
{
	{ 255,255,255,0 },	//
	{ 234,234,234,0 },
	{ 213,213,213,0 },
	{ 191,191,191,0 },
	{ 170,170,170,0 },	//DF
	{ 149,149,149,0 },
	{ 128,128,128,0 },
	{ 106,106,106,0 },
	{  85, 85, 85,0 },	//ZDF
	{  64, 64, 64,0 },
	{  43, 43, 43,0 },
	{  21, 21, 21,0 },
	{   0,  0,  0,0 },	//
};

short dct[]={
  233,549,453,375,310,233,233,233,
  233,233,233,233,310,375,453,549,
};

//AvP[V̏
typedef enum
{
	eAPP_READY = 0,	//ҋ@
	eAPP_PLAY,		//Đ

} eAPPSTATE;

//eXbh̃vg^Cv錾
unsigned __stdcall DrawThreadFunc(void* pParam);
unsigned __stdcall VideoReadThreadFunc(void* pParam);
unsigned __stdcall AudioReadThreadFunc(void* pParam);

//WAVEĐR[obÑvg^Cv錾
void CALLBACK waveOutProc(HWAVEOUT hWout,UINT uMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2);

//炩ߓǂݍłobt@̃t[
#define PRELOAD_AUDIO_FRAMES	(3)	

//Audioobt@̐
#define AUDIO_BUFF_NUM			(3)

//ĐpPCMf[^(16kHz16bit)1t[̃TCY
#define PCM_FRAME_SIZE			(PIECE_MOVIE_AUDIO_DATA_SIZE * 4)

//AvP[V̋ʏ
typedef struct tag_AppInfo
{
	CRITICAL_SECTION m_csVideo;
	CRITICAL_SECTION m_csAudio;
	DWORD			 m_dwDrawFrame;
	DWORD			 m_dwLoadFrame;
	
	BITMAPINFO		*m_pBMPInfo;
	BYTE			 m_abyDIB[PIECE_SCREEN_WIDTH * 
							  PIECE_SCREEN_HEIGHT];
	BYTE			 m_abyDIBWork[PIECE_SCREEN_WIDTH * 
							      PIECE_SCREEN_HEIGHT];
	BYTE			 m_abyDIBOld[PIECE_SCREEN_WIDTH * 
							     PIECE_SCREEN_HEIGHT];
	
	BYTE			*m_apbyAudio[AUDIO_BUFF_NUM];	
	
	int				 m_nPlayAudioBuffIndex;
	int				 m_nLoadAudioBuffIndex;

	eAPPSTATE		 m_eState;
	char			 m_szFileName[_MAX_PATH];

	BOOL			 m_bLoaded;
	BOOL			 m_bStop;
	HANDLE			 m_hDrawThread;
	HANDLE			 m_hVideoReadThread;
  	HANDLE			 m_hAudioReadThread;
	HANDLE			 m_hVideoStartEvent;
	HANDLE			 m_hAudioStartEvent;
	
	HWAVEOUT		 m_hWaveOut;
	WAVEHDR			 m_atWaveHeader[AUDIO_BUFF_NUM];
	
	PMF_FILE_HEADER_TYPE m_tPMTFileHeader;

	//RXgN^
	tag_AppInfo()
	{
		//NeBJZNVIuWFNg̐
		InitializeCriticalSection(&m_csVideo);
		InitializeCriticalSection(&m_csAudio);
			
		//CxgIuWFNg̐
		m_hVideoStartEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
		m_hAudioStartEvent = CreateEvent(NULL,TRUE,FALSE,NULL);
			
		//Audiop̃obt@p
		int i;
		for(i = 0;i < AUDIO_BUFF_NUM;++i)
		{
			m_apbyAudio[i] = NULL;
			m_apbyAudio[i] = (BYTE*)GlobalAlloc(GPTR,PCM_FRAME_SIZE * PRELOAD_AUDIO_FRAMES);
		}

		//ȍ
		Init();
	}

	//fXgN^
	~tag_AppInfo()
	{
		//Đ~
		PlayStop();

		//BMP̍폜
		DeleteBMPInfo();

		//NeBJZNVIuWFNg̍폜
		DeleteCriticalSection(&m_csVideo);
		DeleteCriticalSection(&m_csAudio);
		
		//CxgIuWFNg̍폜
		CloseHandle(m_hVideoStartEvent);
		CloseHandle(m_hAudioStartEvent);

		//Audiopobt@̉
		int i;
		for(i = 0;i < AUDIO_BUFF_NUM;++i)
		{
			GlobalFree(m_apbyAudio[i]);
			m_apbyAudio[i] = NULL;			
		}

	}
	
	//ȍ
	void Init(void)
	{
		m_dwDrawFrame         = 0;
		m_dwLoadFrame         = 0;
		m_eState              = eAPP_READY;
		m_bLoaded             = FALSE;
		m_bStop               = TRUE;
		m_hDrawThread         = NULL;
		m_hVideoReadThread    = NULL;
		m_hAudioReadThread    = NULL;
		m_hWaveOut            = NULL;
		m_nPlayAudioBuffIndex = -1;
		m_nLoadAudioBuffIndex = 0;

		//BMP̍쐬
		CreateBMPInfo();
	}

	//BMP̍쐬
	void CreateBMPInfo(void)
	{
		//폜
		DeleteBMPInfo();

		//̊m
		m_pBMPInfo = (BITMAPINFO*)GlobalAlloc(GPTR,sizeof(BITMAPINFOHEADER) + 
												   sizeof(RGBQUAD) * PCE_GRAYSCALE_DEPTH);

		//ȍ
		m_pBMPInfo->bmiHeader.biSize        = sizeof(BITMAPINFOHEADER);
		m_pBMPInfo->bmiHeader.biWidth       = PIECE_SCREEN_WIDTH;
		m_pBMPInfo->bmiHeader.biHeight      = -PIECE_SCREEN_HEIGHT;	//㌴_̃f[^Ȃ̂ŕ̐
		m_pBMPInfo->bmiHeader.biPlanes      = 1;
		m_pBMPInfo->bmiHeader.biCompression = BI_RGB;
		m_pBMPInfo->bmiHeader.biBitCount    = 8;

		//pbg
		memcpy(m_pBMPInfo->bmiColors,g_atPalette,
			   sizeof(RGBQUAD) * PCE_GRAYSCALE_DEPTH);
	}

	//BMP̍폜
	void DeleteBMPInfo(void)
	{
		//BMP̍폜
		if(m_pBMPInfo != NULL)
		{
			GlobalFree(m_pBMPInfo);
			m_pBMPInfo = NULL;
		}
	}

	//WAVEĐfoCX̃I[v
	void InitWaveDevice(void)
	{
		//gpWAVEtH[}bgw
		WAVEFORMATEX tWaveFormat;
		
		tWaveFormat.wFormatTag      = WAVE_FORMAT_PCM;	//PCM
		tWaveFormat.nChannels       = 1;				//m
		tWaveFormat.wBitsPerSample  = 16;				//16bit
		tWaveFormat.nSamplesPerSec  = 16000;			//16kHz
		tWaveFormat.nBlockAlign     = tWaveFormat.nChannels * tWaveFormat.wBitsPerSample / 8;	//1TṽTCY
		tWaveFormat.nAvgBytesPerSec = tWaveFormat.nSamplesPerSec * tWaveFormat.nBlockAlign;		//rbg[g
		tWaveFormat.cbSize          = 0;				//ǉ񖳂

		//WAVEĐfoCX̃I[v
		waveOutOpen(&m_hWaveOut,WAVE_MAPPER,&tWaveFormat,
					(DWORD_PTR)waveOutProc,(DWORD_PTR)this,CALLBACK_FUNCTION);

		//Đobt@CfbNX̏
		m_nPlayAudioBuffIndex = -1;		
	}

	//WAVEĐ̊Jn
	void PlayWave(void)
	{
		//WAVEĐfoCX̓I[vĂ邩H
		if(m_hWaveOut != NULL)
		{
			//Đobt@CfbNX̏
			m_nPlayAudioBuffIndex = 0;

			//ĐfoCXɍŏ̃obt@Zbg
			WAVEHDR *ptWaveHeader = &m_atWaveHeader[m_nPlayAudioBuffIndex];
			ZeroMemory(ptWaveHeader,sizeof(WAVEHDR));
			ptWaveHeader->lpData = (LPSTR)m_apbyAudio[m_nPlayAudioBuffIndex];
			ptWaveHeader->dwBufferLength = PRELOAD_AUDIO_FRAMES * PCM_FRAME_SIZE;
			ptWaveHeader->dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
			ptWaveHeader->dwLoops = 1;
	
			waveOutPrepareHeader(m_hWaveOut,ptWaveHeader,sizeof(WAVEHDR));

			//ĐJn
			waveOutWrite(m_hWaveOut,ptWaveHeader,sizeof(WAVEHDR));			
		}
	}

	//WAVEĐfoCX̉
	void ReleaseWaveDevice(void)
	{
		//WAVEĐfoCX̓I[vĂ邩H
		if(m_hWaveOut != NULL)
		{
			//Đ~
			waveOutReset(m_hWaveOut);
            
			//obt@foCX؂Ԃ
			int i;
			for(i = 0;i < AUDIO_BUFF_NUM;++i)
			{
				waveOutUnprepareHeader(m_hWaveOut,&m_atWaveHeader[i],sizeof(WAVEHDR));
			}

			//WAVEĐfoCX̃N[Y
			waveOutClose(m_hWaveOut);
			m_hWaveOut = NULL;
		}
	}

	//ĐJn
	void PlayStart(void)
	{
		if(m_bLoaded == FALSE) return;

		//Ô̂~߂
		PlayStop();
		
		//~tONA
		m_bStop = FALSE;

		//ǂݍݏCxgNA
		ResetEvent(m_hVideoStartEvent);
		ResetEvent(m_hAudioStartEvent);

		//Videoǂݍ݃Xbh𐶐
		m_hVideoReadThread = (HANDLE)_beginthreadex(NULL,0,VideoReadThreadFunc,this,0,NULL);

		//WAVEĐfoCX̃I[v
		InitWaveDevice();
				
		//Audioǂݍ݃Xbh𐶐
		m_hAudioReadThread = (HANDLE)_beginthreadex(NULL,0,AudioReadThreadFunc,this,0,NULL);

		//Videoǂݍ݃Xbh̏܂őҋ@
		WaitForSingleObject(m_hVideoStartEvent,INFINITE);

		//Audioǂݍ݃Xbh̏܂őҋ@
		WaitForSingleObject(m_hAudioStartEvent,INFINITE);

		//WAVE̍ĐJn
		PlayWave();
	
		//`Xbh𐶐
		m_hDrawThread = (HANDLE)_beginthreadex(NULL,0,DrawThreadFunc,this,0,NULL);
        		
		//ԂXV
		m_eState = eAPP_PLAY;
	}

	//Đ~
	void PlayStop(void)
	{
		if((m_bLoaded == FALSE) || (m_bStop == TRUE)) return;

		EnterCriticalSection(&m_csAudio);

		//~tOZbg
		m_bStop = TRUE;
		
		//WAVEĐ̒~
		ReleaseWaveDevice();
		
		LeaveCriticalSection(&m_csAudio);

		//Audioǂݍ݃Xbh~
		if(m_hAudioReadThread != NULL)
		{
			//~܂ő҂
			//قƂINFINITEő҂̂̂łA
			//̃\[Xł͍Đ~ɃfbhbN
			//ƂA𒲍ɂ܂薳̂
			//Ƃ肠^CAEgwɂĂ܂B
			//WaitForSingleObject(m_hAudioReadThread,INFINITE);
			WaitForSingleObject(m_hAudioReadThread,3000);

			//Xbhnh
			CloseHandle(m_hAudioReadThread);
			m_hAudioReadThread = NULL;
		}
		
		//Videoǂݍ݃Xbh~
		if(m_hVideoReadThread != NULL)
		{
			//~܂ő҂
			//قƂINFINITEő҂̂̂łA
			//̃\[Xł͍Đ~ɃfbhbN
			//ƂA𒲍ɂ܂薳̂
			//Ƃ肠^CAEgwɂĂ܂B
			//WaitForSingleObject(m_hVideoReadThread,INFINITE);
			WaitForSingleObject(m_hVideoReadThread,3000);

			//Xbhnh
			CloseHandle(m_hVideoReadThread);
			m_hVideoReadThread = NULL;
		}

		//`Xbh~
		if(m_hDrawThread != NULL)
		{
			//~܂ő҂
			//قƂINFINITEő҂̂̂łA
			//̃\[Xł͍Đ~ɃfbhbN
			//ƂA𒲍ɂ܂薳̂
			//Ƃ肠^CAEgwɂĂ܂B
			//WaitForSingleObject(m_hDrawThread,INFINITE);
			WaitForSingleObject(m_hDrawThread,3000);

			//Xbhnh
			CloseHandle(m_hDrawThread);
			m_hDrawThread = NULL;
		}

		//Ƒ҂
		Sleep(500);

		//ԂXV
		m_eState = eAPP_READY;
	}

} APP_INFO;

APP_INFO g_tAppInfo;
HWND g_hMainWnd;


//---------------------------------------------------------------------------
// O[oϐ :
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

// ̃R[h W[Ɋ܂܂֐̐錾]܂ :
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void                InitWindowSize(void);
void                OpenDropFile(HDROP hDrop);
void                OpenPMFFile(LPCTSTR lpszFileName);


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;
	
	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_PMF_PREVIWER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂B:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	//EChEւ̃hbOhbv
	DragAcceptFiles(g_hMainWnd,TRUE);

	//L[ANZ[^[h
	//Alt+?ƂHelpj[J悤ɂȂ܂
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_PMF_PREVIWER);

	timeBeginPeriod(1);

	//exeɃt@Chbvꂽꍇ
	if(strlen(lpCmdLine) > 0)
	{
		//t@CɃXy[Xꍇ""ň͂܂̂ŁA
		//`FbN
		if(*lpCmdLine == '\"')
		{
			//|C^1炷
			lpCmdLine++;

			//_uNH[e[V
			//(t@C̍Ōɗ)I[
			//u
			char *pDq = strrchr(lpCmdLine,'\"');
			if(pDq != NULL) *pDq = '\0';
		}
		
		//t@CJ
		OpenPMFFile(lpCmdLine);	
	}

	// C bZ[W [v :
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	timeEndPeriod(1);

	return (int) msg.wParam;
}



//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg :
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//     Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ 
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_PMF_PREVIWER);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCTSTR)IDC_PMF_PREVIWER;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   ֐ : InitInstance(HANDLE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg :
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{  
   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   //NCAg̈悪w̃TCYɂȂ悤
   //WindowsTCYvZ
   RECT rect;
   SetRect(&rect,0,0,PIECE_SCREEN_WIDTH,PIECE_SCREEN_HEIGHT);

   AdjustWindowRect(&rect,WS_OVERLAPPEDWINDOW,TRUE);
	
   g_hMainWnd = CreateWindow(szWindowClass, szTitle,WS_OVERLAPPEDWINDOW,
				  		     CW_USEDEFAULT, 0,
					         rect.right - rect.left,rect.bottom - rect.top,
					         NULL, NULL, hInstance, NULL);

   if (!g_hMainWnd)
   {
      return FALSE;
   }

   ShowWindow(g_hMainWnd, nCmdShow);
   UpdateWindow(g_hMainWnd);

   return TRUE;
}

//
//  ֐ : WndProc(HWND, unsigned, WORD, LONG)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message) 
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Iꂽj[̉ :
		switch (wmId)
		{
		case IDM_INIT_SIZE:
			InitWindowSize();
			break;
		case IDM_PLAY:
			g_tAppInfo.PlayStart();
			break;
		case IDM_STOP:
			g_tAppInfo.PlayStop();
			break;
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:

			//Đ~
			g_tAppInfo.PlayStop();

			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;

	case WM_DROPFILES:
		//t@ChbOhbvꂽ
		OpenDropFile((HDROP)wParam);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		
			//NCAg̈擾
			RECT rect;
			int width,height;
			GetClientRect(hWnd,&rect);
			width  = rect.right - rect.left;
			height = rect.bottom - rect.top;

			//ʂɃt[`
			StretchDIBits(hdc,0,0,width,height,0,0,PIECE_SCREEN_WIDTH,PIECE_SCREEN_HEIGHT,
						  g_tAppInfo.m_abyDIB,g_tAppInfo.m_pBMPInfo,DIB_RGB_COLORS,SRCCOPY);

		EndPaint(hWnd, &ps);
		break;
	
	case WM_ERASEBKGND:
		return TRUE;

	case WM_DESTROY:

		PostQuitMessage(0);
		break;
	
	case WM_CLOSE:
		
		//Đ~
		g_tAppInfo.PlayStop();

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
	return FALSE;
}

void InitWindowSize(void)
{
	//EChETCY̏

	//NCAg̈悪w̃TCYɂȂ悤
	//WindowsTCYvZ
	RECT rect;
	SetRect(&rect,0,0,PIECE_SCREEN_WIDTH,PIECE_SCREEN_HEIGHT);

	AdjustWindowRect(&rect,WS_OVERLAPPEDWINDOW,TRUE);
	
	SetWindowPos(g_hMainWnd,HWND_TOP,0,0,rect.right - rect.left,rect.bottom - rect.top,
				 SWP_NOMOVE | SWP_NOZORDER);
}

void OpenDropFile(HDROP hDrop)
{
	//hbOꂽt@CJ܂

	//hbOꂽt@C擾
	//(hbvꂽꍇ͍ŏ̂P擾)
	char szFileName[_MAX_PATH];

	DragQueryFile(hDrop,0,szFileName,sizeof(szFileName));
	DragFinish(hDrop);

	//J
	OpenPMFFile(szFileName);
}

void OpenPMFFile(LPCTSTR lpszFileName)
{

	//wPMFt@CJ

	//t@C̊g[q`FbN
	char szExt[_MAX_PATH];
	_splitpath(lpszFileName,NULL,NULL,NULL,szExt);
	CharUpper(szExt);	//Sđ啶

	//PMFt@CH
	if(strcmp(szExt,".PMF") != 0)
	{
		//x
		MessageBox(g_hMainWnd,"hbvꂽt@C\nPMF(P/ECE Movie File format)t@Cł͂܂B",
			       "t@CႢ܂",MB_ICONEXCLAMATION | MB_OK);
	
		//I
		return;
	}

	//VOl``FbN
	FILE *fp = NULL;

	fp = fopen(lpszFileName,"rb");

	if(fp == NULL)
	{
		//x
		MessageBox(g_hMainWnd,"hbvꂽt@CJ܂","t@CI[vG[",
				   MB_ICONEXCLAMATION | MB_OK);

		//I
		return;
	}

	//t@Cwb_ǂݍ
	PMF_FILE_HEADER_TYPE tPMF_FileHeader;

	fread(&tPMF_FileHeader,PMF_FILE_HEADER_SIZE,1,fp);

	fclose(fp);

	//`FbN
	if(tPMF_FileHeader.dwSignature != FCC(PMF_FCC))
	{
		//x
		MessageBox(g_hMainWnd,"t@C̒gsł","t@CeG[",
				   MB_ICONEXCLAMATION | MB_OK);

		
		//I
		return;
	}

	//Đ~
	g_tAppInfo.PlayStop();
	
	//t@Cۑ
	strcpy(g_tAppInfo.m_szFileName,lpszFileName);

	//ǂݍݍς݃tOON
	g_tAppInfo.m_bLoaded = TRUE;

	//ĐJn
	g_tAppInfo.PlayStart();

}

//1t[̃f[^ǂݍ
WORD ReadFrameData(APP_INFO *ptAppInfo,BYTE *pBuff)
{
	WORD wReaded = 0;

EnterCriticalSection(&ptAppInfo->m_csVideo);

	//܂\ĂȂH
	if(ptAppInfo->m_dwDrawFrame < ptAppInfo->m_dwLoadFrame)
		goto ABORT;

	//t[wb_擾
	WORD wFrameHeader = *(WORD*)pBuff;
	pBuff += 2; wReaded += 2;

	//e擾
	WORD wVideoSize  = wFrameHeader & PIECE_MOVIE_VIDEO_SIZE_MASK;
	BOOL bVideoSame  = ((wFrameHeader & PIECE_MOVIE_VIDEO_SAME_MASK) > 0) ? TRUE : FALSE;
	BOOL bVideoKey   = ((wFrameHeader & PIECE_MOVIE_VIDEO_KEY_MASK)  > 0) ? TRUE : FALSE;
	BOOL bAudioUse   = ((wFrameHeader & PIECE_MOVIE_AUDIO_USE_MASK)  > 0) ? TRUE : FALSE;
	
	//Video͗pĂ邩H
	//(ʏVideo͕KĂƎv܂(^^;)
	if(wVideoSize)
	{
		//̃t[̓L[t[H
		if(bVideoKey)
		{
			//1oCg2sNZɂȂĂ̂𕪉
			int nMax = PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT / 2;
			int i;
			for(i = 0;i < nMax;++i)
			{
				//
				ptAppInfo->m_abyDIBWork[i * 2 + 1] = ((*pBuff) & 0x0F);
				ptAppInfo->m_abyDIBWork[i * 2 + 0] = ((*pBuff) >> 4);

				//̃sNZ
				pBuff++;
			}

			wReaded += nMax;
		}
		//Õt[ƑSȂH
		else if(!bVideoSame)
		{
			//1bitmFĂ
			int nMax = PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT;
			int nIndex  = 0;	//ݐCfbNX
			int nBits   = 0;	//rbg
			BYTE byData = *pBuff;
			#define CHECK_8BIT do{ if(nBits == 8){ pBuff++; byData = *pBuff; nBits = 0; } }while(0)
			#define NEXT_BIT   do{ byData <<= 1; nBits++; }while(0) 

			do
			{
				//krbg`FbN
				if(byData & 0x80)
				{
					//kĂ̂ŁAÕf[^𗘗p
					ptAppInfo->m_abyDIBWork[nIndex] = ptAppInfo->m_abyDIBOld[nIndex];

					//̃rbg
					NEXT_BIT;
					CHECK_8BIT;
				}			
				else
				{
					//kĂȂ̂ŁA4bit
					//VsNZlƂėp
					BYTE byColor = 0;
					
					NEXT_BIT;
					CHECK_8BIT;
				
					byColor |= (byData >> 4);
					
					NEXT_BIT;
					CHECK_8BIT;
					byColor |= (byData >> 5);
					
					NEXT_BIT;
					CHECK_8BIT;
					byColor |= (byData >> 6);
					
					NEXT_BIT;
					CHECK_8BIT;
					byColor |= (byData >> 7);

					//擾VsNZlZbg
					ptAppInfo->m_abyDIBWork[nIndex] = byColor;

					if(byColor > 12)
					{
						byColor = 12;
					}

					//̃rbg
					NEXT_BIT;
					CHECK_8BIT;
				}

				//̃sNZ
				nIndex++;

			} while(nIndex < nMax);

			wReaded += wVideoSize;
		}

		//̃f[^Õt[Ƃĕۑ
		memcpy(ptAppInfo->m_abyDIBOld,ptAppInfo->m_abyDIBWork,
			   PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT);
	}

	//Audio͗pĂ邩H
	if(bAudioUse)
	{
		//Audio͓ǂݔ΂
		wReaded += PIECE_MOVIE_AUDIO_DATA_SIZE;
	}

	//ǂݍݍς݃t[XV
	ptAppInfo->m_dwLoadFrame++;

ABORT:

LeaveCriticalSection(&ptAppInfo->m_csVideo);

	return wReaded;
}

#include <crtdbg.h> /* _RPT0C_RPT1C_RPT2C_RPT3C_RPT4 ɂ͕Kv */

//Videoǂݍ݃Xbh
unsigned __stdcall VideoReadThreadFunc(void* pParam)
{
	APP_INFO *ptAppInfo = (APP_INFO*)pParam;

	//t@CJ
	//xI[veXgĂ͂Ȃ̂ŁA
	//ł̃I[v`FbN͂܂B
	//قƂ͂ǂˁBTvȂ̂ŁB

	HANDLE hFile     = NULL;
	HANDLE hFileMap  = NULL;;
	BYTE  *pFileBuff = NULL;
	BYTE  *pBuff     = NULL;;
	DWORD dwFileSize = 0;
	DWORD dwDataEnd  = 0;		//2005/08/08 Added by Madoka

	//Ɗyă}bvht@CƂĊJ
	hFile     = CreateFile(ptAppInfo->m_szFileName,GENERIC_READ,FILE_SHARE_READ,
						   NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	hFileMap  = CreateFileMapping(hFile,NULL,PAGE_READONLY,0,0,NULL);
	pFileBuff = (BYTE*)MapViewOfFile(hFileMap,FILE_MAP_READ,0,0,0);
	pBuff = pFileBuff;

	//t@CTCY̎擾
	dwFileSize = GetFileSize(hFile,NULL);

	//PMFt@Cwb_̎擾
	ptAppInfo->m_tPMTFileHeader = *(PMF_FILE_HEADER_TYPE*)pBuff;
	pBuff += PMF_FILE_HEADER_SIZE;

	//2005/08/08 Added by Madoka
	//f[^̏I[ݒ
	dwDataEnd = ptAppInfo->m_tPMTFileHeader.dwOffsetForKeyList;

	//1t[ڂ̃f[^ǂݍ
	pBuff += ReadFrameData(ptAppInfo,pBuff);

	//ł̂ŁACxgIuWFNgVOiԂ
	SetEvent(ptAppInfo->m_hVideoStartEvent);

	//ǂݍ݃[v
	while(!ptAppInfo->m_bStop)
	{
		//ĐH
		if(ptAppInfo->m_eState == eAPP_PLAY)
		{
			//̃t[ǂݍ
			pBuff += ReadFrameData(ptAppInfo,pBuff);

			//Ō܂œǂ񂾂
			if((DWORD)(pBuff - pFileBuff) >= dwDataEnd)	//2005/08/08 Changed by Madoka dwFileSize  dwDataEnd
				ptAppInfo->m_bStop = TRUE;	//~߂

			//̃XbhCPU𖾂n
			Sleep(0);
		}
	}

	//t@C
	UnmapViewOfFile(pFileBuff);
	CloseHandle(hFileMap);
	CloseHandle(hFile);
    
	_endthreadex(0);

	return 0;
}

//`Xbh
unsigned __stdcall DrawThreadFunc(void* pParam)
{
	APP_INFO *ptAppInfo = (APP_INFO*)pParam;

	//w莞ԂƂɊG؂ւ
	//قƂ15.625FPS64msȂ̂łAP/ECE̕\xCɂȂ̂ŁA
	//  f[^͔FPSɂȂĂ܂BŁAWindowsłFPSŕ\
	//@ςx̂ŁA64msŒƂ܂B܂llɂłł͂
	//  ܂񂪁AƂ肠ĂB
	double dAddFlipTime = 64.0;//1000.0 / (double)(ptAppInfo->m_tPMTFileHeader.wfix8FPS  / 256.0);	
	double dFlipTime    = dAddFlipTime;
	DWORD dwStartTime   = timeGetTime();
    DWORD dwNextTime    = dwStartTime + (DWORD)dFlipTime;

	while(!ptAppInfo->m_bStop)
	{
		//ĐH
		if(ptAppInfo->m_eState == eAPP_PLAY)
		{
			//O񂩂w莞ԂoH
			DWORD dwNowTime = timeGetTime();
			if(dwNowTime >= dwNextTime)
			{
				//ǂݍ܂Ă邩H
				if(ptAppInfo->m_dwDrawFrame < ptAppInfo->m_dwLoadFrame)
				{					
					//\f[^̓ւ
					EnterCriticalSection(&ptAppInfo->m_csVideo);
					
						memcpy(ptAppInfo->m_abyDIB,ptAppInfo->m_abyDIBWork,
							   PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT);	
						InvalidateRect(g_hMainWnd,NULL,FALSE);
						UpdateWindow(g_hMainWnd);

						//\ς݃t[̍XV
						ptAppInfo->m_dwDrawFrame++;

					LeaveCriticalSection(&ptAppInfo->m_csVideo);
				}
			
				//̕\Zo
				dFlipTime += dAddFlipTime;
				dwNextTime = dwStartTime + (DWORD)dFlipTime;
			}

			//̃XbhCPU𖾂n
			Sleep(0);
		}
	}

	_endthreadex(0);

	return 0;
}

//ADPCMPCMւ̃fR[h
void decode(signed short *wave,unsigned char *adp,int size)
{
  int delta=16,pcm=0,i;
  for(i=0;i<size;i++){
    int h,l;
    h=*adp++;
    l=h&0xf;
    h>>=4;
    pcm+=delta*(h-8);
    delta=(delta*dct[h])>>8;
    *wave++=(short)pcm;
    pcm+=delta*(l-8);
    delta=(delta*dct[l])>>8;
    *wave++=(short)pcm;
  }
}

//Audiof[^1t[ǂݍ
WORD ReadAudioData(APP_INFO *ptAppInfo,BYTE *pBuff,int *pnLoadedFrame)
{
	WORD wReaded = 0;
		
EnterCriticalSection(&ptAppInfo->m_csAudio);
					
	//ĐȂH
	if(ptAppInfo->m_nLoadAudioBuffIndex ==
	   ptAppInfo->m_nPlayAudioBuffIndex)
		goto ABORT;

	//ǂݍݐobt@NA
	if(*pnLoadedFrame == 0)
	{
		memset(ptAppInfo->m_apbyAudio[ptAppInfo->m_nLoadAudioBuffIndex],
			   0,PRELOAD_AUDIO_FRAMES * PCM_FRAME_SIZE);
	}

	//t[wb_擾
	WORD wFrameHeader = *(WORD*)pBuff;
	pBuff += 2; wReaded += 2;

	//e擾
	WORD wVideoSize = wFrameHeader & PIECE_MOVIE_VIDEO_SIZE_MASK;
	BOOL bAudioUse  = ((wFrameHeader & PIECE_MOVIE_AUDIO_USE_MASK)  > 0) ? TRUE : FALSE;
	
	//Videof[^̕ǂݔ΂
	pBuff += wVideoSize; wReaded += wVideoSize;

	//Audio͗pĂ邩H
	if(bAudioUse)
	{
		//Audiof[^͌ŒTCYȂ̂
		//CɎo
		BYTE abyAudio[PIECE_MOVIE_AUDIO_DATA_SIZE];
		
		ZeroMemory(abyAudio,sizeof(abyAudio));
		memcpy(abyAudio,pBuff,PIECE_MOVIE_AUDIO_DATA_SIZE);
		wReaded += PIECE_MOVIE_AUDIO_DATA_SIZE;
		
		//ADPCMPCMɃfR[h
		decode((short*)(ptAppInfo->m_apbyAudio[ptAppInfo->m_nLoadAudioBuffIndex] + 
			   *pnLoadedFrame * PCM_FRAME_SIZE),
			   abyAudio,PIECE_MOVIE_AUDIO_DATA_SIZE);
	}

	//̃t[
	(*pnLoadedFrame)++;

ABORT:

LeaveCriticalSection(&ptAppInfo->m_csAudio);

	return wReaded;
}

//Audioǂݍ݃Xbh
unsigned __stdcall AudioReadThreadFunc(void* pParam)
{
	APP_INFO *ptAppInfo = (APP_INFO*)pParam;

	//t@CJ
	//xI[veXgĂ͂Ȃ̂ŁA
	//ł̃I[v`FbN͂܂B
	//قƂ͂ǂˁBTvȂ̂ŁB

	HANDLE hFile     = NULL;
	HANDLE hFileMap  = NULL;;
	BYTE  *pFileBuff = NULL;
	BYTE  *pBuff     = NULL;;
	DWORD dwFileSize = 0;
	DWORD dwDataEnd  = 0;		//2005/08/08 Added by Madoka
	int nLoadedFrame = 0;

	//Ɗyă}bvht@CƂĊJ
	hFile     = CreateFile(ptAppInfo->m_szFileName,GENERIC_READ,FILE_SHARE_READ,
						   NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	hFileMap  = CreateFileMapping(hFile,NULL,PAGE_READONLY,0,0,NULL);
	pFileBuff = (BYTE*)MapViewOfFile(hFileMap,FILE_MAP_READ,0,0,0);
	pBuff = pFileBuff;

	//t@CTCY̎擾
	dwFileSize = GetFileSize(hFile,NULL);

	//PMFt@Cwb_̎擾
	ptAppInfo->m_tPMTFileHeader = *(PMF_FILE_HEADER_TYPE*)pBuff;
	pBuff += PMF_FILE_HEADER_SIZE;

	//2005/08/08 Added by Madoka
	//f[^̏I[ݒ
	dwDataEnd = ptAppInfo->m_tPMTFileHeader.dwOffsetForKeyList;

	//wt[̃f[^ǂݍ
	ptAppInfo->m_nLoadAudioBuffIndex = 0;
	while(nLoadedFrame < PRELOAD_AUDIO_FRAMES)
	{
		pBuff += ReadAudioData(ptAppInfo,pBuff,&nLoadedFrame);
		
		//Ō܂œǂ񂾂܂̓XgbvꂽH
		if(((DWORD)(pBuff - pFileBuff) >= dwDataEnd) ||	//2005/08/08 Changed by Madoka dwFileSize  dwDataEnd
			ptAppInfo->m_bStop != FALSE)	
			break;
	}
		
	//ǂݍݐobt@̃CfbNXXV
	ptAppInfo->m_nLoadAudioBuffIndex++;

	//ł̂ŁACxgIuWFNgVOiԂ
	SetEvent(ptAppInfo->m_hAudioStartEvent);

	//ǂݍ݃[v
	while(!ptAppInfo->m_bStop)
	{
		//ĐH
		if(ptAppInfo->m_eState == eAPP_PLAY)
		{
			//wt[̃f[^ǂݍ
			nLoadedFrame = 0;
			while(nLoadedFrame < PRELOAD_AUDIO_FRAMES)
			{
				pBuff += ReadAudioData(ptAppInfo,pBuff,&nLoadedFrame);
				
				//Ō܂œǂ񂾂܂̓XgbvꂽH
				if(((DWORD)(pBuff - pFileBuff) >= dwDataEnd) ||	//2005/08/08 Changed by Madoka dwFileSize  dwDataEnd
					ptAppInfo->m_bStop != FALSE)	
					break;
			}

			if(!ptAppInfo->m_bStop)
			{
				//ĐfoCXɃobt@Zbg
				WAVEHDR *ptWaveHeader = &ptAppInfo->m_atWaveHeader[ptAppInfo->m_nLoadAudioBuffIndex];
				ZeroMemory(ptWaveHeader,sizeof(WAVEHDR));
				ptWaveHeader->lpData = (LPSTR)ptAppInfo->m_apbyAudio[ptAppInfo->m_nLoadAudioBuffIndex];
				ptWaveHeader->dwBufferLength = PRELOAD_AUDIO_FRAMES * PCM_FRAME_SIZE;
				ptWaveHeader->dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
				ptWaveHeader->dwLoops = 1;

				EnterCriticalSection(&ptAppInfo->m_csAudio);

				waveOutPrepareHeader(ptAppInfo->m_hWaveOut,ptWaveHeader,sizeof(WAVEHDR));

				//Đ\
				MMRESULT r;
				r= waveOutWrite(ptAppInfo->m_hWaveOut,ptWaveHeader,sizeof(WAVEHDR));	
				
				//ǂݍݐobt@̃CfbNXXV
				ptAppInfo->m_nLoadAudioBuffIndex++;
				ptAppInfo->m_nLoadAudioBuffIndex %= AUDIO_BUFF_NUM;

				LeaveCriticalSection(&ptAppInfo->m_csAudio);
			}

			//̃XbhCPU𖾂n
			Sleep(0);

			//Ō܂œǂ񂾏ꍇ͉~߂
			if((DWORD)(pBuff - pFileBuff) >= dwDataEnd)	//2005/08/08 Changed by Madoka dwFileSize  dwDataEnd
				break;
		}
	}
		
	//Xgbv܂őҋ@
	while(!ptAppInfo->m_bStop)
	{
		//̃XbhCPU𖾂n			
		Sleep(0);
	}
	
	EnterCriticalSection(&ptAppInfo->m_csAudio);

	//WAVEĐ̒~
	ptAppInfo->ReleaseWaveDevice();
		
	LeaveCriticalSection(&ptAppInfo->m_csAudio);

	//t@C
	UnmapViewOfFile(pFileBuff);
	CloseHandle(hFileMap);
	CloseHandle(hFile);
    
	_endthreadex(0);

	return 0;
}

//WAVEĐR[obN
void CALLBACK waveOutProc(HWAVEOUT hWout,UINT uMsg,DWORD dwInstance,DWORD dwParam1,DWORD dwParam2)
{
	APP_INFO *ptAppInfo = (APP_INFO*)dwInstance;

	//WAVEĐfoCX̓I[vĂ邩H
	if(ptAppInfo->m_hWaveOut != NULL)
	{
		//ÕubN̍ĐÎH
		if((uMsg == WOM_DONE) && (ptAppInfo->m_bStop == FALSE))
		{
			EnterCriticalSection(&ptAppInfo->m_csAudio);

			//̃obt@
			ptAppInfo->m_nPlayAudioBuffIndex++;
			ptAppInfo->m_nPlayAudioBuffIndex %= AUDIO_BUFF_NUM;

			LeaveCriticalSection(&ptAppInfo->m_csAudio);
		}
	}
}










