#include <windows.h>
#include <Streams.h>
#include <initguid.h>
#include <math.h>
#include ".\piecegrayconv.h"
#include "..\\lib\\PMF_Header.h"

//---------------------------------------------------------------------------
// P/ECẼXN[萔 
//---------------------------------------------------------------------------
#define PCE_CC				'PCEG'	//PieceGraytH[}bgFOURCC

#define PCE_GRAYSCALE_DEPTH	(13)	//P/ECȆK\̐[x(K)

#define BLACK_THRESHOLD		(64)	//摜Ƃ臒l
#define WHITE_THRESHOLD		(192)	//摜Ƃ臒l

//#define FRAME_CUT_OUT		//t[؂osꍇ̓RgĂ

//Kpbg
RGBQUAD g_atPalette[PCE_GRAYSCALE_DEPTH] = 
{
	{ 255,255,255,0 },	//
	{ 234,234,234,0 },
	{ 213,213,213,0 },
	{ 191,191,191,0 },
	{ 170,170,170,0 },	//DF
	{ 149,149,149,0 },
	{ 128,128,128,0 },
	{ 106,106,106,0 },
	{  85, 85, 85,0 },	//ZDF
	{  64, 64, 64,0 },
	{  43, 43, 43,0 },
	{  21, 21, 21,0 },
	{   0,  0,  0,0 },	//
};

//256KOCXP[13K̃pbg
//CfbNXɕϊe[u
unsigned char g_abyGrayToPaletteTable[] = 
{
 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12, 12,
 12, 12, 12, 12, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11,
 11, 11, 11, 11, 11, 11, 11, 11, 10, 10, 10, 10, 10, 10, 10, 10,
 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10,  9,  9,  9,  9,
  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,  9,
  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,  8,
  8,  8,  8,  8,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,  7,
  7,  7,  7,  7,  7,  7,  7,  7,  6,  6,  6,  6,  6,  6,  6,  6,
  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  6,  5,  5,  5,  5,
  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  5,  4,  4,  4,  4,
  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,  4,
  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,  3,
  3,  3,  3,  3,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,  2,
  2,  2,  2,  2,  2,  2,  2,  2,  1,  1,  1,  1,  1,  1,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
};

#ifdef FRAME_CUT_OUT	//t[؂osꍇ̂ݗp

	#include <stdio.h>
	DWORD g_dwFrameIndex;
	
#endif //FRAME_CUT_OUT

//---------------------------------------------------------------------------
// tB^̐錾 
//---------------------------------------------------------------------------

//tB^
static const WCHAR g_wszFilterName[] = L"Piece Gray Converter";

// Setup information

const AMOVIESETUP_MEDIATYPE sudInMediaTypes[] =
{
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_RGB32 },
};

const AMOVIESETUP_MEDIATYPE sudOutMediaTypes[] =
{
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_RGB8 },
};

const AMOVIESETUP_PIN sudpPins[] =
{
    { L"Input",             // s
      FALSE,                // ̃s̓_O邩H
      FALSE,                // o̓sH
      FALSE,                // tB^̓[̃CX^X쐬ł邩H
      FALSE,                // tB^͕̃CX^X쐬ł邩H
      &CLSID_NULL,          // ݎgĂȂ
      NULL,                 // ݎgĂȂ
      1,                    // fBA^Cv̐
      sudInMediaTypes       // fBA^Cvւ̃|C^
    },
    { L"Output",            // s
      FALSE,                // ̃s̓_O邩H
      TRUE,                 // o̓sH
      FALSE,                // tB^̓[̃CX^X쐬ł邩H
      FALSE,                // tB^͕̃CX^X쐬ł邩H
      &CLSID_NULL,          // ݎgĂȂ
      NULL,                 // ݎgĂȂ
      1,                    // fBA^Cv̐
      sudOutMediaTypes      // fBA^Cvւ̃|C^
    }
};

const AMOVIESETUP_FILTER sudPieceGrayConv =
{
    &CLSID_PieceGrayConv,	// tB^ CLSID
    g_wszFilterName,		// tB^
    MERIT_DO_NOT_USE,	    // bg
    2,                      // s^Cv̐
    sudpPins                // sւ̃|C^
};


// List of class IDs and creator functions for the class factory. This
// provides the link between the OLE entry point in the DLL and an object
// being created. The class factory will call the static CreateInstance

CFactoryTemplate g_Templates[] = {
    { 
	  g_wszFilterName,					//O
      &CLSID_PieceGrayConv,				//CLSID
      CPieceGrayConv::CreateInstance,	//쐬֐
      NULL,
      &sudPieceGrayConv					//tB^ւ̃|C^
	} 
};
int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);



//---------------------------------------------------------------------------
// DLL֘A 
//---------------------------------------------------------------------------
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
//DLLGg|Cg
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}
//---------------------------------------------------------------------------
// WXgւ̓o^
STDAPI DllRegisterServer()
{
	return AMovieDllRegisterServer2(TRUE);
}
//---------------------------------------------------------------------------
// WXg̉
STDAPI DllUnregisterServer()
{
	return AMovieDllRegisterServer2(FALSE);
}
//---------------------------------------------------------------------------
// Piece Gray Converter tB^NX 
//---------------------------------------------------------------------------
CPieceGrayConv::CPieceGrayConv(void) :
				CTransformFilter(NAME("Piece Gray Converter"),0,CLSID_PieceGrayConv) 
{
	//RXgN^

	//e탁ȍ
	InitMember();

}
//---------------------------------------------------------------------------
CPieceGrayConv::~CPieceGrayConv(void)
{
	//fXgN^

	//e탁o̍폜
	DeleteWorkImage();
	DeleteGrayWorkImage();	//2005/07/24 Added by Madoka
	DeleteGammaTable();		//2005/07/26 Added by Madoka

}
//---------------------------------------------------------------------------
void CPieceGrayConv::InitMember(void)
{

	//ȍ
	
	m_hMemDC         = NULL;
	m_hOldBitmap     = NULL;
	m_pbyDIB         = NULL;	
	m_tWorkSize.cx   = 0;
	m_tWorkSize.cy   = 0;
	m_tPixelSize.cx  = 0;
	m_tPixelSize.cy  = 0;
	m_pbyGrayDIB     = NULL;		//2005/07/24 Added by Madoka
	m_bAutoContrast  = FALSE;		//2005/07/24 Added by Madoka	
	m_pabyGammaTable = NULL;		//2005/07/26 Added by Madoka	
	m_bGammaCorrect  = FALSE;		//2005/07/26 Added by Madoka

#ifdef FRAME_CUT_OUT	//t[؂osꍇ̂ݗp
	
	g_dwFrameIndex = 0;
	
#endif	//FRAME_CUT_OUT

}
//---------------------------------------------------------------------------
int CPieceGrayConv::gcd(int m,int n)
{

	//ő񐔂߂
	//̃R[h𗘗pĂ܂B肪Ƃ܂B
	//http://www.hidecnet.ne.jp/~sinzan/tips/c/c_tip0a.htm

	//*********************************************************
	// ő񐔁iGreatest Common DivisorjԂB
	// ɂOꍇ͂OԂB
	//*********************************************************

	// ɂOꍇ͂OԂ
	if ( ( 0 == m ) || ( 0 == n ) )
		return 0;
	
	// [Nbȟݏ@
	while( m != n )
	{
		if ( m > n ) m = m - n;
		else         n = n - m;
	}
	return m;
}
//---------------------------------------------------------------------------
int CPieceGrayConv::lcm(int m,int n)
{

	//ŏ{߂
	//̃R[h𗘗pĂ܂B肪Ƃ܂B
	//http://www.hidecnet.ne.jp/~sinzan/tips/c/c_tip0a.htm

	//*********************************************************
	// ŏ{iLeast Common MultiplejԂB
	// ɂOꍇ͂OԂB
	//*********************************************************

	// ɂOꍇ͂OԂ
	if ( ( 0 == m ) || ( 0 == n ) )
		return 0;
	
	return m * n / gcd(m, n);
}
//---------------------------------------------------------------------------
BOOL CPieceGrayConv::CreateWorkImage(BITMAPINFOHEADER *pInHeader)
{

	//[NC[W̍쐬
	
	//EncodeFrame\bhœ͉摜P/ECẼXN[TCY
	//ɏk̂łAkۂɓ͉摜̃TCYɂẮA
	//kꂽsNZɑ΂錳摜̖ʐς̕Eɒ[
	//ꍇA̒[𖳂߂Ɉxg債Ă
	//kƂKvɂȂ܂B

	//kɂ͖ʐϕϖ@(ωf@)Ƃ@p܂B
	//ڂ́̃TCgFXǂĉ(^^;
	//http://www.marumo.ne.jp/db2000_c.htm#18

	//ł͊g債摜ێ郏[NGAƂDIBZNV
	//쐬A̕ϊŎg񂵂܂B

	//mۂC[W̃TCÝA͉摜̕EP/ECE
	//XN[E̍ŏ{̃TCYɂȂ܂B

	BOOL bRet = FALSE;

	//ȑÔ͍̂폜
	DeleteWorkImage();

	//ƗpC[W̃TCYZo
	int nAreaWidth  = lcm(pInHeader->biWidth ,PIECE_SCREEN_WIDTH);
	int nAreaHeight = lcm(pInHeader->biHeight,PIECE_SCREEN_HEIGHT); 

	//DCDIBZNV쐬
	HDC hScreenDC = GetDC(HWND_DESKTOP);	//XN[DC擾

	//DC̍쐬
	m_hMemDC = CreateCompatibleDC(hScreenDC);

	//DIBZNV̍쐬
	HBITMAP hDIB = NULL;
	BITMAPINFO tBMPInfo = *((BITMAPINFO*)pInHeader);
	tBMPInfo.bmiHeader.biWidth     = nAreaWidth;
	tBMPInfo.bmiHeader.biHeight    = nAreaHeight;
	tBMPInfo.bmiHeader.biSizeImage = DIBSIZE(tBMPInfo.bmiHeader);

	hDIB = CreateDIBSection(hScreenDC,&tBMPInfo,DIB_RGB_COLORS,(VOID**)&m_pbyDIB,NULL,0);

	//ɍ쐬łH
	if(hDIB != NULL)
	{
		//쐬DIBZNVDCɑI
		m_hOldBitmap = (HBITMAP)SelectObject(m_hMemDC,hDIB);
	
		//TCYۑ
		m_tWorkSize.cx = nAreaWidth;
		m_tWorkSize.cy = nAreaHeight;

		//PsNŽ摜̗̈TCYۑ
		m_tPixelSize.cx = nAreaWidth  / PIECE_SCREEN_WIDTH;
		m_tPixelSize.cy = nAreaHeight / PIECE_SCREEN_HEIGHT;

		//
		bRet = TRUE;
	}

	ReleaseDC(HWND_DESKTOP,hScreenDC);		//XN[DC

	return bRet;
}
//---------------------------------------------------------------------------
void CPieceGrayConv::DeleteWorkImage(void)
{

	//[NC[W̍폜
	
	if(m_pbyDIB != NULL)
	{
		DeleteObject(SelectObject(m_hMemDC,m_hOldBitmap));
		DeleteDC(m_hMemDC);
	}

	//
	m_hMemDC        = NULL;
	m_hOldBitmap    = NULL;
	m_pbyDIB        = NULL;	
	m_tWorkSize.cx  = 0;
	m_tWorkSize.cy  = 0;
	m_tPixelSize.cx = 0;
	m_tPixelSize.cy = 0;
}
//---------------------------------------------------------------------------
//2005/07/24 Added by Madoka
BOOL CPieceGrayConv::CreateGrayWorkImage(void)
{

	//P/ECEʃTCỸOCXP[[N쐬
	
	BOOL bRet = TRUE;

	//ȑÔ͍̂폜
	DeleteGrayWorkImage();

	//P/ECEʃTCY̔z쐬
	m_pbyGrayDIB = new BYTE[PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT];

	if(m_pbyGrayDIB == NULL)
		bRet = FALSE;

	return bRet;
}
//---------------------------------------------------------------------------
//2005/07/24 Added by Madoka
void CPieceGrayConv::DeleteGrayWorkImage(void)
{

	//P/ECEʃTCỸOCXP[[N폜

	if(m_pbyGrayDIB != NULL)
	{
		delete[] m_pbyGrayDIB;
		m_pbyGrayDIB = NULL;
	}
}
//---------------------------------------------------------------------------
//2005/07/26 Added by Madoka
BOOL CPieceGrayConv::CreateGammaTable(double dGamma)
{
	
	//K}␳e[u쐬
	BOOL bRet = FALSE;

	//ȑÔ͍̂폜
	DeleteGammaTable();

	//m
	m_pabyGammaTable = new BYTE[256];

	if(m_pabyGammaTable != NULL)
	{
		//e[u쐬
		int i;
		for(i = 0;i < 256;++i)
		{
			double v = pow((double)i / 256.0,1.0 / dGamma);
			int Y = (int)(v * 256.0);
			
			//
			if(Y > 255) Y = 255;
			if(Y < 0)   Y = 0;

			m_pabyGammaTable[i] = (BYTE)Y;
		}

		//I
		bRet = TRUE;
	}

	return bRet;
}
//---------------------------------------------------------------------------
//2005/07/26 Added by Madoka
void CPieceGrayConv::DeleteGammaTable(void)
{

	//K}␳e[u폜
	
	if(m_pabyGammaTable != NULL)
	{
		delete[] m_pabyGammaTable;
		m_pabyGammaTable = NULL;
	}
}
//---------------------------------------------------------------------------
CUnknown * WINAPI CPieceGrayConv::CreateInstance(LPUNKNOWN pUnk, HRESULT *pHr)
{
	//CX^X̍쐬

    CPieceGrayConv *pFilter = new CPieceGrayConv();
    if (pFilter== NULL) 
    {
        *pHr = E_OUTOFMEMORY;
    }
    return pFilter;
}
//---------------------------------------------------------------------------
//2005/07/27 Added by Madoka
STDMETHODIMP CPieceGrayConv::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{
	//AvP[VQueryInterfaceɉ

    CheckPointer(ppv,E_POINTER);

	//PieceGrayConṽC^[tF[XvH
    if (riid == IID_IPieceGrayConv) {
        return GetInterface((IPieceGrayConv *) this, ppv);					//ԓ
    } else {
        return CTransformFilter::NonDelegatingQueryInterface(riid, ppv);	//ftHg
    }

}
//---------------------------------------------------------------------------
//2005/07/27 Added by Madoka
STDMETHODIMP CPieceGrayConv::get_AutoContrastFlag(BOOL *pbAutoContrast)
{
	//RgXgtO̎擾
    CheckPointer(pbAutoContrast,E_POINTER);
    CAutoLock cAutoLock(&m_AutoContrastLock);

    *pbAutoContrast = m_bAutoContrast;
    return NOERROR;

}
//---------------------------------------------------------------------------
//2005/07/27 Added by Madoka
STDMETHODIMP CPieceGrayConv::put_AutoContrastFlag(BOOL bAutoContrast)
{
	//RgXgtO̐ݒ
    CAutoLock cAutoLock(&m_AutoContrastLock);
    m_bAutoContrast = bAutoContrast;
    return NOERROR;

}
//---------------------------------------------------------------------------
//2005/07/27 Added by Madoka
STDMETHODIMP CPieceGrayConv::get_GammaCorrectFlag(BOOL *pbGammaCorrect)
{
	//K}␳tO̎擾
    CheckPointer(pbGammaCorrect,E_POINTER);
    CAutoLock cAutoLock(&m_GammaCorrectLock);

    *pbGammaCorrect = m_bGammaCorrect;
    return NOERROR;

}
//---------------------------------------------------------------------------
//2005/07/27 Added by Madoka
STDMETHODIMP CPieceGrayConv::put_GammaCorrectFlag(BOOL bGammaCorrect)
{
	//K}␳tO̐ݒ
    CAutoLock cAutoLock(&m_GammaCorrectLock);
    m_bGammaCorrect = bGammaCorrect;
    return NOERROR;

}
//---------------------------------------------------------------------------
HRESULT CPieceGrayConv::MediaCheck(const CMediaType *MediaType)
{
	// fBA^Cṽ`FbN

	// VideoH
	if( IsEqualGUID( *MediaType->Type(),MEDIATYPE_Video ) )				
	{
		// RGB32bit^CvH
		if( IsEqualGUID( *MediaType->Subtype(),MEDIASUBTYPE_RGB32) ) 	  
		{
			VIDEOINFOHEADER *pvi=(VIDEOINFOHEADER *)MediaType->Format();
			
			// rbgJEg32bitł邩H
			if( pvi->bmiHeader.biBitCount == 32 )						 
			{
				// OK
				return S_OK;
			}
		}
	}

	// NG
	return VFW_E_TYPE_NOT_ACCEPTED;
}
//---------------------------------------------------------------------------
HRESULT CPieceGrayConv::CheckInputType(const CMediaType *mtIn)
{
	//̓fBA^Cṽ`FbN

	//`̃`FbN
	if ((mtIn->majortype  != MEDIATYPE_Video)    ||
        (mtIn->subtype    != MEDIASUBTYPE_RGB32) ||
        (mtIn->formattype != FORMAT_VideoInfo)   || 
        (mtIn->cbFormat < sizeof(VIDEOINFOHEADER)))
    {
		//̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	//DIB̃`FbN
	//32bit̖kDIBH
	VIDEOINFOHEADER *pVih = 
        reinterpret_cast<VIDEOINFOHEADER*>(mtIn->pbFormat);
    if ((pVih->bmiHeader.biBitCount    != 32) ||
        (pVih->bmiHeader.biCompression != BI_RGB))
    {
        //̌`̓T|[gĂ܂
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

	//SĖȂ
	return S_OK;
}
//---------------------------------------------------------------------------
HRESULT CPieceGrayConv::GetMediaType(int iPosition, CMediaType *pMediaType)
{
	//fBA^Cv̎擾

	//ڑς݂H
	ASSERT(m_pInput->IsConnected());	
	if (m_pInput->IsConnected() == FALSE) {
        return E_UNEXPECTED;
    }

	//Do̓^CṽCfbNXԍ0ȏォH
    if (iPosition < 0)
    {
        return E_INVALIDARG;
    }

	//o̓^Cv͂Pł
    if (iPosition == 0)
    {
		//tH[}bgubNɕKvȃ蓖Ă
		VIDEOINFOHEADER *pVih = (VIDEOINFOHEADER*)pMediaType->AllocFormatBuffer(sizeof(VIDEOINFOHEADER) +
																			    sizeof(RGBQUAD) * PCE_GRAYSCALE_DEPTH);
		if (pVih == 0) 
			return(E_OUTOFMEMORY);
		
		//̓s̃fBA^Cv擾
		//(o̓fBA^Cv̏̃x[XƂ)
		AM_MEDIA_TYPE mt;
        HRESULT hr = m_pInput->ConnectionMediaType(&mt);
        if (FAILED(hr))
        {
            return hr;
        }
		
		//x[XƂtH[}bgubNRs[
		memcpy(pMediaType->pbFormat,mt.pbFormat,mt.cbFormat);
		pMediaType->formattype           = mt.formattype;
		pMediaType->majortype            = mt.majortype;
		pMediaType->pUnk                 = mt.pUnk;

		//ꎞIɐtH[}bg ubN
	    FreeMediaType(mt);
			
		//o̓fBA^Cvݒ
        FOURCCMap fccMap = FOURCCMap(PCE_CC); 
        pMediaType->subtype = static_cast<GUID>(fccMap);//FOURCCR[hݒ
        pMediaType->SetSampleSize(PIECE_SCREEN_WIDTH *
								  PIECE_SCREEN_HEIGHT);	//ŒTvTCYݒ
        pMediaType->SetTemporalCompression(FALSE);		//Xg[͎n(t[)kgpĂ܂

		//DIBZbg
        ASSERT(pMediaType->formattype == FORMAT_VideoInfo);
        pVih->bmiHeader.biWidth     = PIECE_SCREEN_WIDTH;
		pVih->bmiHeader.biHeight    = PIECE_SCREEN_HEIGHT;
		pVih->bmiHeader.biBitCount  = 8;
		pVih->bmiHeader.biSizeImage = DIBSIZE(pVih->bmiHeader); 
        
		//pbgZbg
		BITMAPINFO *pBmpInfo = (BITMAPINFO*)&(pVih->bmiHeader);
		int i;

		pBmpInfo->bmiHeader.biClrImportant = 0;						//ׂĂ̐Fdv
		pBmpInfo->bmiHeader.biClrUsed      = PCE_GRAYSCALE_DEPTH;	//ĝ13F
		for(i = 0;i < PCE_GRAYSCALE_DEPTH;++i)
		{
			//pbgZbg
			pBmpInfo->bmiColors[i] = g_atPalette[i];	//13K̃OCXP[ݒ
		}

		//]`ݒ
		SetRect(&pVih->rcTarget,0,0,PIECE_SCREEN_WIDTH,PIECE_SCREEN_HEIGHT);

		return S_OK;
    }
    // else
    return VFW_S_NO_MORE_ITEMS;
}
//---------------------------------------------------------------------------
HRESULT CPieceGrayConv::CheckTransform(const CMediaType *mtIn, const CMediaType *mtOut)
{
	//񎦂ꂽo̓^Cv݂̓̓^Cv
	//݊邩ǂ𒲂ׂ

	// W[ ^Cv𒲂ׂ
    if (mtOut->majortype != MEDIATYPE_Video)
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    // Tu^CvƃtH[}bg ^Cv𒲂ׂ
	FOURCCMap fccMap = FOURCCMap(PCE_CC); 
    if (mtOut->subtype != static_cast<GUID>(fccMap))
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }
    if ((mtOut->formattype != FORMAT_VideoInfo) || 
        (mtOut->cbFormat < sizeof(VIDEOINFOHEADER)))
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    // rbg}bvƏo̓^Cv`FbN
    ASSERT(mtIn->formattype == FORMAT_VideoInfo);
    BITMAPINFOHEADER *pBmiOut = HEADER(mtOut->pbFormat);
    if ((pBmiOut->biPlanes      != 1)                ||
        (pBmiOut->biBitCount    != 8)                ||
        (pBmiOut->biCompression != BI_RGB)           ||
        (pBmiOut->biWidth       != PIECE_SCREEN_WIDTH) ||
        (pBmiOut->biHeight      != PIECE_SCREEN_HEIGHT))
    {
        return VFW_E_TYPE_NOT_ACCEPTED;
    }

    //]`Ɠ]``FbN
    RECT rcImg;
    SetRect(&rcImg, 0, 0, PIECE_SCREEN_WIDTH, PIECE_SCREEN_HEIGHT);
    RECT *prcSource = &((VIDEOINFOHEADER*)(mtIn->pbFormat))->rcSource;
	RECT *prcTarget = &((VIDEOINFOHEADER*)(mtOut->pbFormat))->rcTarget;
    if (((prcSource->right - prcSource->left) < PIECE_SCREEN_WIDTH)  ||
		((prcSource->bottom - prcSource->top) < PIECE_SCREEN_HEIGHT) ||
		!IsRectEmpty(prcTarget) && !EqualRect(prcTarget, &rcImg))
    {
		//`̓`FbNȂĂǂ炵B
		//̃tB^ɂȂtB^̒ɂ́A
		//rcSource̒gׂ0݂̂̂
		//A𖳎ĂɏłĂ
		//悤Ȃ̂ŁB
        //return VFW_E_INVALIDMEDIATYPE;
    }
    
    // ׂĖȂ
    return S_OK;
}
//---------------------------------------------------------------------------
HRESULT CPieceGrayConv::DecideBufferSize(IMemAllocator *pAlloc,
									     ALLOCATOR_PROPERTIES *pProp)
{
	//AP[^ݒ

	//ڑς݂H
	if (m_pInput->IsConnected() == FALSE) {
        return E_UNEXPECTED;
    }

	//o̓fBA^Cv擾
	AM_MEDIA_TYPE mt;
    HRESULT hr = m_pOutput->ConnectionMediaType(&mt);
    if (FAILED(hr))
    {
        return hr;
    }

	//AP[^vpeBɒlZbg
	ASSERT(mt.formattype == FORMAT_VideoInfo);
    BITMAPINFOHEADER *pbmi = HEADER(mt.pbFormat);
    pProp->cbBuffer = DIBSIZE(*pbmi) * 2; 
    if (pProp->cbAlign == 0)
    {
        pProp->cbAlign = 1;
    }
    if (pProp->cBuffers == 0)
    {
        pProp->cBuffers = 1;
    }
    
	//ꎞIɐtH[}bg ubN
    FreeMediaType(mt);

    // AP[^ vpeBݒ肷
    ALLOCATOR_PROPERTIES Actual;
    hr = pAlloc->SetProperties(pProp, &Actual);
    if (FAILED(hr)) 
    {
        return hr;
    }

    // ꍇAۂ̌ʂmF
    if (pProp->cbBuffer > Actual.cbBuffer) 
    {
        return E_FAIL;
    }

    return S_OK;
}
//---------------------------------------------------------------------------
HRESULT CPieceGrayConv::CompleteConnect(PIN_DIRECTION direction,IPin *pReceivePin)
{

	//sڑ̏

	//͉摜̏擾
	AM_MEDIA_TYPE* pType = &m_pInput->CurrentMediaType();
    VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)pType->pbFormat;
    ASSERT(pvi);

	//[NC[W̍쐬
	if(CreateWorkImage(&pvi->bmiHeader) == FALSE)
		return S_FALSE;
	if(CreateGrayWorkImage() == FALSE)			//2005/07/24 Added by Madoka
		return S_FALSE;
	
	//K}␳e[u̍쐬
	if(CreateGammaTable(GAMMA_VALUE) == FALSE)	//2005/07/26 Added by Madoka
		return S_FALSE;

	return S_OK;
}
//---------------------------------------------------------------------------	
HRESULT CPieceGrayConv::Transform(IMediaSample *pIn, IMediaSample *pOut)
{
	
	//C[Wϊ

	// ɂȂobt@ւ̃|C^擾
    BYTE *pBufferIn, *pBufferOut;
    HRESULT hr;

	hr = pIn->GetPointer(&pBufferIn);
    if (FAILED(hr))
    {
        return hr;
    }
    hr = pOut->GetPointer(&pBufferOut);
    if (FAILED(hr))
    {
        return hr;
    }

	//͉摜̏擾
	AM_MEDIA_TYPE* pType = &m_pInput->CurrentMediaType();
    VIDEOINFOHEADER *pvi = (VIDEOINFOHEADER *)pType->pbFormat;
    ASSERT(pvi);

	// f[^
    DWORD cbDest = EncodeFrame(&pvi->bmiHeader,(RGB32_TYPE*)pBufferIn, pBufferOut);
    KASSERT((long)cbDest <= pOut->GetSize());

#ifdef FRAME_CUT_OUT	//t[؂osꍇ̏
	
	//t@CI[v
	char szFileName[_MAX_PATH];
	FILE *fp = NULL;

	sprintf(szFileName,"Frame%06ld.bmp",g_dwFrameIndex);
	fp = fopen(szFileName,"wb");

	if(fp != NULL)
	{
		//t@Cwb_[쐬
		BITMAPFILEHEADER tBMPFileHeader;

		ZeroMemory(&tBMPFileHeader,sizeof(BITMAPFILEHEADER));
		tBMPFileHeader.bfType = WORD(0x4D42);	//'BM'
		tBMPFileHeader.bfSize = sizeof(BITMAPFILEHEADER) +
								sizeof(BITMAPINFOHEADER) +
								sizeof(RGBQUAD) * 256 + 
								PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT;
		tBMPFileHeader.bfOffBits = tBMPFileHeader.bfSize - 
								   PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT;

		//BMPwb_[쐬
		BITMAPINFOHEADER tBMPInfoHeader;

		ZeroMemory(&tBMPInfoHeader,sizeof(BITMAPINFOHEADER));
		tBMPInfoHeader.biSize        = sizeof(BITMAPINFOHEADER);
		tBMPInfoHeader.biWidth       = PIECE_SCREEN_WIDTH;
		tBMPInfoHeader.biHeight      = PIECE_SCREEN_HEIGHT;
		tBMPInfoHeader.biPlanes      = 1;
		tBMPInfoHeader.biBitCount    = 8;
		tBMPInfoHeader.biCompression = BI_RGB;
		
		//t@Cwb_o
		fwrite(&tBMPFileHeader,sizeof(BITMAPFILEHEADER),1,fp);

		//BMPwb_o
		fwrite(&tBMPInfoHeader,sizeof(BITMAPINFOHEADER),1,fp);

		//pbgo
		fwrite(g_atPalette,sizeof(RGBQUAD),256,fp);

		//DIBf[^o
		fwrite(pBufferOut,1,PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT,fp);
	
		//t@CN[Y
		fclose(fp);
	}

	//t[CfbNXXV
	g_dwFrameIndex++;

#endif	//FRAME_CUT_OUT

	//ϊ̃TCYZbg
    pOut->SetActualDataLength(cbDest);
   
	//ׂăL[t[ƂĐݒ
	pOut->SetSyncPoint(TRUE);

    return S_OK;
}
//---------------------------------------------------------------------------
DWORD CPieceGrayConv::EncodeFrame(BITMAPINFOHEADER *pInHeader,RGB32_TYPE *pInBuff,BYTE *pOutBuff)
{

	//C[Wϊ̃RA

	DWORD dwDstSize = 0;

	//2005/07/24 Changed by Madoka
	//]̃tJ[摜13KP/ECẼOCXP[
	//ϊs̒ɁA256K̃OCXP[ɕϊ
	//ĂÃOCXP[摜ŎRgXg
	//Ƃ}Aɂ݂₷摜Ƃĕϊ悤
	//ɏύX܂B
	

	//͂ꂽ摜P/ECẺʃTCYł
	//128*88ɏkA13K̃OCXP[
	//ϊ܂B
	//̕ϊ͏k݂̂T|[g܂

	//kɂ͖ʐϕϖ@(ωf@)Ƃ@p܂B
	//ڂ́̃TCgFXǂĉ(^^;
	//http://www.marumo.ne.jp/db2000_c.htm#18

	//͉摜ŏ{̃TCYɊg
	StretchDIBits(m_hMemDC,0,0,m_tWorkSize.cx,m_tWorkSize.cy,
				  0,0,pInHeader->biWidth,pInHeader->biHeight,
				  (const VOID*)pInBuff,(const BITMAPINFO*)pInHeader,
				  DIB_RGB_COLORS,SRCCOPY);

	//o͐0ŏ
	memset(m_pbyGrayDIB,0,PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT);
	memset(pOutBuff  ,0,PIECE_SCREEN_WIDTH * PIECE_SCREEN_HEIGHT);

	//܂́Ag債摜k摜1sNZ̗̈̐F̕ς
	//ƂāAɂ̐FPxlɕϊP/ECEʃTCY̔z
	//OCXP[(256K)Ƃĕۑ܂B
	int nMotoX,nMotoY;
	int x,y,YValue;
	RGB32_TYPE *pMoto = (RGB32_TYPE*)m_pbyDIB;
	RGB32_TYPE *pWork;
	BYTE *pGrayOut = m_pbyGrayDIB;
	DWORD dwR,dwG,dwB;
	int nAddNextLineOffsetForInLoop  = (m_tWorkSize.cx - m_tPixelSize.cx);
	int nAddNextLineOffsetForOutLoop = m_tWorkSize.cx * (m_tPixelSize.cy - 1);
	DWORD dwDiv = (DWORD)(m_tPixelSize.cx * m_tPixelSize.cy);

	for(y = 0;y < PIECE_SCREEN_HEIGHT;++y)
	{
		for(x = 0;x < PIECE_SCREEN_WIDTH;++x)
		{
			//摜̏kΏۗ̈̐F𕽋ω
			dwR = dwG = dwB = 0;
			pWork = pMoto;

			for(nMotoY = 0;nMotoY < m_tPixelSize.cy;++nMotoY)
			{
				for(nMotoX = 0;nMotoX < m_tPixelSize.cx;++nMotoX)
				{
					//̃sNZ̐F擾
					dwR += pMoto->R;
					dwG += pMoto->G;
					dwB += pMoto->B;

					//̃sNZ
					pMoto++;
				}

				//̃C
				pMoto += nAddNextLineOffsetForInLoop;
			}

			//ϐFZo
			dwR /= dwDiv;
			dwG /= dwDiv;
			dwB /= dwDiv;

			//Pxl擾
			YValue = ConvRGBtoY((double)dwR,(double)dwG,(double)dwB);

			//Pxlۑ
			*pGrayOut = (BYTE)YValue;

			//̃sNZ
			pMoto = pWork + m_tPixelSize.cx;
			pGrayOut++;
		}

		//̃C
		pMoto += nAddNextLineOffsetForOutLoop;
	}

	//ɎRgXĝ߂̏ƂāA摜̋Px𒲍
	//Px̃qXgOz쐬܂B
    
	//ۑOCXP[̉摜f[^APx̃qXgOz쐬
	int anHistgram[256];
	int i;
	
	i = 0;
	memset(anHistgram,0,sizeof(anHistgram));
	for(y = 0;y < PIECE_SCREEN_HEIGHT;++y)
	{
		for(x = 0;x < PIECE_SCREEN_WIDTH;++x)
		{
			//JEgAbv
			anHistgram[m_pbyGrayDIB[i]]++;			
			i++;
		}
	}

	//łɂقڔ̉摜Aقڍ̉摜̓RgXg
	//PxqXgO̕LĂ܂ƁA摜Ƃꂽ
	//摜ɂȂĂ܂̂ŁAŔ摜E摜̃`FbN
	//܂B
	//摜⍕摜Ɣ肳ꂽꍇ́ARgXg
	//K}␳Ȃ悤ɂ܂B
	BOOL bBlack   = TRUE;
	BOOL bWhite   = TRUE;
	BOOL bCorrect = TRUE;	//␳stO

	//摜E摜`FbN
	for(i = 0;i < WHITE_THRESHOLD;++i)
	{
		//ЂƂłɉfΒʏ摜
		if(anHistgram[i] > 0)
		{
			bWhite = FALSE;
			break;
		}
	}
	for(i = BLACK_THRESHOLD;i < 255;++i)
	{
		//ЂƂłɉfΒʏ摜
		if(anHistgram[i] > 0)
		{
			bBlack = FALSE;
			break;
		}
	}

	//摜⍕摜̓RgXgEK}␳͖
	if((bWhite == TRUE) || (bBlack == TRUE))
	{
		bCorrect = FALSE;	//␳͎s܂
	}

	//␳p̃e[u쐬
	BYTE abyYTable[256];
	if(bCorrect)
	{
		//Px̍ŏƍő𒲍
		double dMinY = 0.0;
		double dMaxY = 255.0;
		
		//ŏPx`FbN
		for(i = 0;i < 256;++i)
		{
			//Â猩čŏɌPxŏPx
			if(anHistgram[i] > 0)
			{
				dMinY = (double)i;
				break;
			}
		}

		//őPx`FbN
		for(i = 255;i >= 0;--i)
		{
			//邢猩čŏɌPxőPx
			if(anHistgram[i] > 0)
			{
				dMaxY = (double)i;
				break;
			}
		}

		//RgXgł́APx̍ŏlƍőlꂼ
		//0255ɂȂ悤Ɍ̋Pxlɑ΂Ċg又s
		//Ŏ܂B
		//
		//ϊɎgp鎮͈ȉ̒ʂB
		//(min,max͌摜̍ŏPxlƍőPxl)
		//
		// Y' = Y * (255.0 / (max - min)) - min 
		//

		//g嗦Zo
		double dA = (255.0 / (dMaxY - dMinY));

		//Pxϊe[u쐬
		for(i = 0;i < 256;++i)
		{
			//Px			
			int nY = (int)((double)i * dA - dMinY);

			//Y̒l̐
			if(nY > 255) nY = 255;
			if(nY < 0)   nY = 0;

			abyYTable[i] = (BYTE)nY;
		}
	}

	//256K̃OCXP[P/ECE13KOCXP[
	//̃pbgCfbNXɕϊďo

	int nGosa;
	i = 0;
	for(y = 0;y < PIECE_SCREEN_HEIGHT;++y)
	{
		for(x = 0;x < PIECE_SCREEN_WIDTH;++x)
		{
			//Pxl擾
			//(RgXge[ugēɏ)
			if(bCorrect)
			{
				if(m_bAutoContrast)			
					YValue = abyYTable[m_pbyGrayDIB[i]];
				else
					YValue = m_pbyGrayDIB[i];

				//K}␳
				if(m_bGammaCorrect)
					YValue= m_pabyGammaTable[YValue];
			}
			else YValue = m_pbyGrayDIB[i];
			
			//덷Z
			YValue += (int)(*(char*)pOutBuff);	//tŃLXg
			if(YValue > 255) YValue = 255;
			if(YValue < 0)   YValue = 0;

			//pbgCfbNXo
			*pOutBuff = g_abyGrayToPaletteTable[YValue];

			//덷Zo
			nGosa = YValue - g_atPalette[*pOutBuff].rgbRed;
			
			//덷gU
			//+------+------+------+
			//|      | this | 7/16 |
			//+------+------+------+
			//| 3/16 | 5/16 | 1/16 |
			//+------+------+------+
			
			if((x + 1) < PIECE_SCREEN_WIDTH)
			{
				// 7/16
				*(pOutBuff + 1) += (BYTE)(((nGosa << 3) - nGosa) >> 4);	
			}

			if((y + 1) < PIECE_SCREEN_HEIGHT)
			{
				if(x > 0)
				{
					// 3/16
					*(pOutBuff - 1 + PIECE_SCREEN_WIDTH) += (BYTE)(((nGosa << 1) + nGosa) >> 4);
				}

				// 5/16
				*(pOutBuff + PIECE_SCREEN_WIDTH) += (BYTE)(((nGosa << 2) + nGosa) >> 4);
	
				if((x + 1) < PIECE_SCREEN_WIDTH)
				{
					// 1/16
					*(pOutBuff + 1 + PIECE_SCREEN_WIDTH) += (BYTE)(nGosa >> 4);
				}
			}

			//̃sNZ
			i++;
			pOutBuff++;

			//PsNZI
			dwDstSize++;
		}
	}

	return dwDstSize;
}
//---------------------------------------------------------------------------
int CPieceGrayConv::ConvRGBtoY(double dR,double dG,double dB)
{

	//RGBPxlɕϊ
	int nY;

	nY = (int)(0.299 * dR + 0.587 * dG + 0.114 * dB);
	
	//
	if(nY > 255) nY = 255;
	if(nY < 0)   nY = 0;

	return nY;
}
//---------------------------------------------------------------------------
