#include <windows.h>
#include <Streams.h>
#include <initguid.h>
#include "DllMain.h"
#include "..\\lib\\PMF_Header.h"
#include "PieceMovieFileMux.h"

//---------------------------------------------------------------------------
// tB^̐錾 
//---------------------------------------------------------------------------

//tB^
static const WCHAR g_wszFilterName[] = L"Piece Movie File Mux";

// Setup information

const AMOVIESETUP_MEDIATYPE sudInVideoMediaTypes[] =
{
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_RGB8 },
};

const AMOVIESETUP_MEDIATYPE sudInAudioMediaTypes[] =
{
    { &MEDIATYPE_Audio, &MEDIASUBTYPE_PCM  },
};

const AMOVIESETUP_MEDIATYPE sudOutMediaTypes[] =
{
	{ &MEDIATYPE_Video, &MEDIASUBTYPE_RGB8 },
};

const AMOVIESETUP_PIN sudpPins[] =
{
    { L"Video Input",       // s
      FALSE,                // ̃s̓_O邩H
      FALSE,                // o̓sH
      FALSE,                // tB^̓[̃CX^X쐬ł邩H
      FALSE,                // tB^͕̃CX^X쐬ł邩H
      &CLSID_NULL,          // ݎgĂȂ
      NULL,                 // ݎgĂȂ
      1,                    // fBA^Cv̐
      sudInVideoMediaTypes  // fBA^Cvւ̃|C^
    },
    { L"Audio Input",       // s
      FALSE,                // ̃s̓_O邩H
      FALSE,                // o̓sH
      FALSE,                // tB^̓[̃CX^X쐬ł邩H
      FALSE,                // tB^͕̃CX^X쐬ł邩H
      &CLSID_NULL,          // ݎgĂȂ
      NULL,                 // ݎgĂȂ
      1,                    // fBA^Cv̐
      sudInAudioMediaTypes  // fBA^Cvւ̃|C^
    }
};

const AMOVIESETUP_FILTER sudPieceMovieFileMux =
{
    &CLSID_PieceMovieFileMux,	// tB^ CLSID
    g_wszFilterName,			// tB^
    MERIT_DO_NOT_USE,			// bg
    2,							// s^Cv̐
    sudpPins					// sւ̃|C^
};


// List of class IDs and creator functions for the class factory. This
// provides the link between the OLE entry point in the DLL and an object
// being created. The class factory will call the static CreateInstance

CFactoryTemplate g_Templates[] = {
    { 
	  g_wszFilterName,							//O
      &CLSID_PieceMovieFileMux,					//CLSID
      CPieceMovieFileMuxFilter::CreateInstance,	//쐬֐
      NULL,
      &sudPieceMovieFileMux						//tB^ւ̃|C^
	} 
};
int g_cTemplates = sizeof(g_Templates) / sizeof(g_Templates[0]);



//---------------------------------------------------------------------------
// DLL֘A 
//---------------------------------------------------------------------------
extern "C" BOOL WINAPI DllEntryPoint(HINSTANCE, ULONG, LPVOID);
//DLLGg|Cg
BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
    return DllEntryPoint((HINSTANCE)(hModule), dwReason, lpReserved);
}
//---------------------------------------------------------------------------
// WXgւ̓o^
STDAPI DllRegisterServer()
{
	return AMovieDllRegisterServer2(TRUE);
}
//---------------------------------------------------------------------------
// WXg̉
STDAPI DllUnregisterServer()
{
	return AMovieDllRegisterServer2(FALSE);
}
//---------------------------------------------------------------------------